package emc.gui;

import java.awt.*;
import java.net.*;
import java.util.*;
import jftp.*;

/*
 *
 * FTPBrowser
 *
 */
public class FTPBrowser extends Dialog
{
   	
	GridBagLayout lm = null;
	Label dirLabel = null;
	java.awt.List dirList = null;
	Label fileLabel = null;
	java.awt.List fileList = null;
	Button cancelButton = null;
	
	Dimension d = new Dimension(480,300);

	public String file_chosen = null;
	public boolean ftp_error_occured = false;
	private boolean done = false;

	FtpModule ftp_module;



	FTPBrowser(Frame parent, String title, FtpModule ftp_module_param)
	{
		super(parent, title, true);
		try
		{
			resize(d);
			lm = new GridBagLayout();
			setLayout(lm);
			GridBagConstraints c = new GridBagConstraints();
			dirLabel = new Label("Directories                        . . .");
			add(dirLabel);
			c.gridx=0;
			c.gridy=0;
			c.gridwidth = 1;
			c.fill = GridBagConstraints.HORIZONTAL;
			lm.setConstraints(dirLabel,c);
			dirList = new java.awt.List(10,false);
			for(int i = 0; i < 15; i++)
			{
				dirList.addItem("DIRECTORY__________________________________");
			}
			add(dirList);
			c.gridx=0;
			c.gridy=1;
			c.gridwidth = 2;
			lm.setConstraints(dirList,c);
			fileLabel = new Label("Files                             . . .");
			add(fileLabel);
			c.gridx=2;
			c.gridy=0;
			c.gridwidth = 1;
			c.fill = GridBagConstraints.HORIZONTAL;
			lm.setConstraints(fileLabel,c);
			fileList = new java.awt.List(10,false);
			for(int i = 0; i < 15; i++)
			{
				fileList.addItem("FILE____________________________________");
			}
			add(fileList);
			c.gridx=2;
			c.gridy=1;
			c.gridwidth = 2;
			lm.setConstraints(fileList,c);
			cancelButton = new Button("Cancel");
			add(cancelButton);
			c.fill = GridBagConstraints.NONE;
			c.gridx = 0;
			c.gridy =2;
			c.gridwidth = 1;
			lm.setConstraints(cancelButton,c);
			ftp_module = ftp_module_param;
			ReadFTPList();
			if(!ftp_error_occured)
			{
				show();
			}
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}

	public boolean isDone()
	{
		return done;
	}

	void ReadFTPList()
	{
		FileNameInfo files[] = ftp_module.list();
		if(null == files)
		{
			file_chosen = null;
			ftp_error_occured = true;
			dispose();
			return;
		}
		dirList.clear();
		fileList.clear();
		for(int i = 0; i < files.length; i++)
		{
			if(files[i].isDirectory())
			{
				dirList.addItem(files[i].getFileName());
			}
			else
			{
				fileList.addItem(files[i].getFileName());
			}
		}
	}


	public boolean action(Event evt, Object what)
	{
		if(evt.target.equals(cancelButton))
		{
			done = true;
			dispose();
			return true;
		}
		if(evt.target.equals(dirList))
		{
			String new_dir = dirList.getSelectedItem();
			if(null != new_dir)
			{
				System.out.println("FTPBrowser: new_dir = "+new_dir);
				ftp_module.chdir(new_dir);
				if(null == file_chosen)
				{
					file_chosen = new_dir+"/";
				}
				else
				{
					file_chosen += new_dir+"/";
				}
				ReadFTPList();
			}
			return true;
		}
		if(evt.target.equals(fileList))
		{
			String new_file = fileList.getSelectedItem();
			if(null != new_file)
			{
				System.out.println("FTPBrowser: new_file = "+new_file);
				if(null == file_chosen)
				{
					file_chosen = new_file;
				}
				else
				{
					file_chosen += new_file;
				}
				System.out.println("FTPBrowser: file_chosen = "+file_chosen);
				done = true;
				dispose();
			}
			return true;
		}
		return super.action(evt,what);
	}

	public Dimension preferredSize()
	{
		return d;
	}

	public Dimension minimumSize()
	{
		return d;
	}

}

