//******************************************************************************
// NCapplet.java:	Applet
//
//******************************************************************************/

package emc.gui;

import java.io.*;
import java.util.*;
import java.net.*;
import java.applet.*;
import java.awt.*;

import emc.gui.NCappletFrame;
import emc.nml.*;

import rcs.*;
import rcs.nml.*;
import rcs.utils.*;
import rcs.posemath.*;
import jftp.*;


//==============================================================================
// Main Class for applet NCapplet
//
//==============================================================================
public class NCapplet extends Applet implements Runnable
{
  // NML Objects
  NMLConnection NCStatusChannel = null;
  NMLConnection NCCommandChannel = null;
  NMLConnection NCErrlogChannel = null;
  EMC_STAT ncStatus = null;
  EMC_STAT ncStatusOld = null;
  int nc_serial_number = 0;
  public boolean read_errlog = true;
  public boolean repaint_needed = true;
  double cycle_time = 0.5;

  

  // Display Controls
  FlowLayout mainLayout = null;
  Panel mainInnerPanel = null;
  GridBagLayout mainInnerLayout = null;
  Label titleBarLabel = null;
  Button newWindowButton = null;
  Button initButton = null;
  QueryDialog initQueryDialog = null;
  Button abortButton = null;
  Panel choiceStatusPanel = null;
  GridBagLayout choiceStatusLayout = null;
  Panel choicePanel = null;
  CardLayout choiceLayout = null;
  PositionDisplayPanel positionPanel = null;
  Panel programPanel = null;
  FlowLayout programLayout = null;
  Panel programInnerPanel = null;
  GridBagLayout programInnerLayout = null;
  java.awt.List programList = null;
  TextField programTextField = null;
  Button loadProgramButton = null;
  Button browseLocalButton = null;
  Button browseRemoteButton = null;
  Button runButton = null;
  Button haltButton = null;
  Button holdButton = null;
  Button resumeButton = null;
  Button singleStepButton = null;
  Label XProgPosLabel = null;
  Label YProgPosLabel = null;
  Label ZProgPosLabel = null;
  Label XProgOffsetLabel = null;
  Label YProgOffsetLabel = null;
  Label ZProgOffsetLabel = null;
  Label GCodesLabel1 = null;
  Label GCodesLabel2 = null;
  Label MCodesLabel1 = null;
  Label MCodesLabel2 = null;
  Label mdiLabel = null;
  TextArea mdiOldCommandsArea = null;
  TextField mdiExecField = null;
  Button mdiExecButton = null;
  Panel toolTablePanel = null;		
  FlowLayout toolTableLayout = null;
  Panel toolTableInnerPanel = null;
  GridBagLayout toolTableInnerLayout = null;
  TextField toolTableTextField = null;
  Button toolTableLoadButton = null;
  java.awt.List toolTableList = null;
  Panel errlogPanel = null;
  FlowLayout errlogLayout = null;
  Panel errlogInnerPanel = null;
  GridBagLayout errlogInnerLayout = null;
  Checkbox readErrlogCheckbox = null;
  Button clearErrlogButton = null;
  TextArea errlogTextArea = null;
  Panel cpanelPanel = null;
  FlowLayout cpanelLayout = null;
  Panel cpanelInnerPanel = null;
  GridBagLayout cpanelInnerLayout = null;
  Button estopResetButton = null;
  Button estopButton = null;
  Button machineOnButton = null;
  Button machineOffButton = null;
  Label modeLabel = null;
  Button autoButton = null;
  Button manualButton = null;
  Button mdiButton = null;
  Checkbox autoSetModeCheckbox = null;
  Label jogTypeLabel = null;
  Choice jogTypeChoice = null;
  Label jogSpeedLabel = null;
  Scrollbar jogSpeedSlider =null;
  Label axisControlLabel = null;
  JogButton XJogPlusButton = null;
  JogButton YJogPlusButton = null;
  JogButton ZJogPlusButton = null;
  JogButton XJogMinusButton = null;
  JogButton YJogMinusButton = null;
  JogButton ZJogMinusButton = null;
  Button XHomeButton = null;
  Button YHomeButton = null;
  Button ZHomeButton = null;
  Label XPositionLabel = null;
  Label YPositionLabel = null;
  Label ZPositionLabel = null;
  Checkbox XEnableCheckbox = null;
  Checkbox YEnableCheckbox = null;
  Checkbox ZEnableCheckbox = null;
  Checkbox XLocalOffsetCheckbox = null;
  Checkbox YLocalOffsetCheckbox = null;
  Checkbox ZLocalOffsetCheckbox = null;
  double x_local_offset = 0;
  double y_local_offset = 0;
  double z_local_offset = 0;
  Label feedrateOverrideLabel = null;
  Scrollbar feedrateOverrideSlider = null;
  Label spindleOverrideLabel = null;
  Scrollbar spindleOverrideSlider = null;
  Label spindleControlLabel = null;
  Button spindleCCWButton = null;
  Button spindleOffButton = null;
  Button spindleCWButton = null;
  Checkbox spindleBrakeCheckbox = null;
  JogButton spindleIncrButton = null;
  JogButton spindleDecrButton = null;
  Label userNameLabel = null;
  TextField userNameField = null;
  Label userPasswdLabel = null;
  TextField userPasswdField = null;
  Checkbox connectedCheckbox = null;
  Label NMLfileLabel = null;
  TextField NMLfileTextField = null;
  Checkbox relativePositionCheckbox = null;
  CheckboxGroup unitsGroup = null;
  Checkbox inchesCheckbox = null;
  Checkbox mmCheckbox = null;
  Button memCleanCheckButton = null;
  Label cycleTimeLabel = null;
  Scrollbar cycleTimeScrollbar = null;
  Label HeartBeatLabel = null;
  Label TaskHeartBeatLabel = null;
  Label IoHeartBeatLabel = null;
  Label MotionHeartBeatLabel = null;
  Label GuiHeartBeatLabel = null;

  Panel statusPanel = null;
  GridLayout statusLayout = null;
  Label estopStatusLabel = null;
  Label powerStatusLabel = null;
  Label programStatusLabel = null;
  Label execStatusLabel = null;
  Label inposStatusLabel = null;
  Label errlogStatusLabel = null;
  Label modeStatusLabel = null;
  Label feedrateStatusLabel = null;
  Label spindleStatusLabel = null;
  Label homingStatusLabel = null;
  Label homedStatusLabel = null;
  Label loginStatusLabel = null;

  Panel buttonPanel = null;
  GridLayout buttonPanelLayout = null;
  Button positionButton = null;
  Button programButton = null;
  Button toolTableButton = null;
  Button cpanelButton = null;
  Button errlogButton = null;


  // Miscellaneous variables
  boolean relative_position = false;
  int num_errors = 0;
  int num_new_errors = 0;
  int num_stat_updates = 0;
  boolean load_program_requested = false;
  boolean browse_remote_requested = false;
  boolean browse_local_requested = false;
  double jog_scale = 1.0;
  int jog_speed = 25;
  static public final int INCH_UNITS = 1;
  static public final int MILLIMETER_UNITS = 2;
  static public final double MILLIMETERS_TO_INCHES = (1/25.4);
  static public final double INCHES_TO_MILLIMETERS = 25.4;
  int unit_type = MILLIMETER_UNITS;
  int old_unit_type = MILLIMETER_UNITS;
  Vector old_mdi_commands = new Vector();
  int current_mdi_command_index = 0;
  boolean is_connected = false;
  static public int nc_applet_count = 0;
  static public boolean debug_on = false;

  String choice_layout_selection = "position";

  static public String newline = "\n";
  static {
    try
      {
	String temp_newline = System.getProperty("line.separator");
	if(null != temp_newline)
	  {
	    newline = temp_newline;
	  }
      }
    catch(Exception e)
      {
	e.printStackTrace();
      }
  }		

  // THREAD SUPPORT:
  //		m_NCapplet	is the Thread object for the applet
  //--------------------------------------------------------------------------
  Thread	 m_NCapplet = null;

  // STANDALONE APPLICATION SUPPORT:
  //		m_fStandAlone will be set to true if applet is run standalone
  //--------------------------------------------------------------------------
  boolean m_fStandAlone = false;

  // PARAMETER SUPPORT:
  //		Parameters allow an HTML author to pass information to the applet;
  // the HTML author specifies them using the <PARAM> tag within the <APPLET>
  // tag.  The following variables are used to store the values of the
  // parameters.
  //--------------------------------------------------------------------------

  // Members for applet parameters
  // <type>       <MemberVar>    = <Default Value>
  //--------------------------------------------------------------------------
  private static String m_NMLfile = "emc.nml";
  private String m_InitFile = "nce.ini";
  private String m_ToolTable = "tool.tbl";
  private String m_NCProgBase = "ftp://isdftp.cme.nist.gov/users/shackle/emc/";
  private boolean m_UseColor = true;
  private String m_InterpreterDialect = "RS274NGC";
  private String m_InchCode = "G20";
  private String m_MilliMeterCode = "G21";
  private double m_MCodeFactor = 0.1;
  private double m_GCodeFactor = 0.1;
  private String m_UserPasswd = "";
  private String m_UserName = "";
  private boolean run_local = false;


  // Parameter names.  To change a name of a parameter, you need only make
  // a single change.  Simply modify the value of the parameter string below.
  //--------------------------------------------------------------------------
private final String PARAM_NMLfile = "NMLfile";
private final String PARAM_InitFile = "InitFile";
private final String PARAM_ToolTable = "ToolTable";
private final String PARAM_NCProgBase = "NCProgBase";
private final String PARAM_UseColor = "UseColor";
private final String PARAM_InterpreterDialect = "InterpreterDialect";
private final String PARAM_InchCode = "InchCode";
private final String PARAM_MilliMeterCode = "MilliMeterCode";
private final String PARAM_MCodeFactor = "MCodeFactor";
private final String PARAM_GCodeFactor = "GCodeFactor";
private final String PARAM_UserPasswd = "UserPasswd";
private final String PARAM_UserName = "UserName";
private final String PARAM_DebugOn = "DebugOn";
private final String PARAM_RunLocal = "RunLocal";



  // Create Some messages here to avoid too much allocation/garbage collection
  EMC_AXIS_ABORT axis_stop_msg = new EMC_AXIS_ABORT();
  EMC_AXIS_ENABLE axis_enable_msg = new EMC_AXIS_ENABLE();
  EMC_AXIS_DISABLE axis_disable_msg = new EMC_AXIS_DISABLE();
  EMC_AXIS_HOME homeMsg = new EMC_AXIS_HOME();
  EMC_AXIS_INCR_JOG incr_jog_msg = new EMC_AXIS_INCR_JOG();
  EMC_AXIS_JOG jog_msg = new EMC_AXIS_JOG();
  EMC_TASK_SET_MODE modeMsg = new EMC_TASK_SET_MODE();
  EMC_TASK_ABORT abortMsg = new EMC_TASK_ABORT();
  EMC_TASK_PLAN_EXECUTE exec_msg = new EMC_TASK_PLAN_EXECUTE();
  EMC_TASK_HALT haltMsg = new EMC_TASK_HALT();
  EMC_TASK_PLAN_PAUSE pauseMsg = new EMC_TASK_PLAN_PAUSE();
  EMC_TASK_PLAN_RESUME resumeMsg = new EMC_TASK_PLAN_RESUME();
  EMC_TASK_SET_STATE stateMsg = new EMC_TASK_SET_STATE();
  EMC_TASK_PLAN_STEP stepMsg = new EMC_TASK_PLAN_STEP();
  EMC_SPINDLE_OFF spindleOffMsg = new EMC_SPINDLE_OFF();
  EMC_SPINDLE_ON spindleOnMsg = new EMC_SPINDLE_ON();
  EMC_SPINDLE_INCREASE spindleIncrMsg = new EMC_SPINDLE_INCREASE();
  EMC_SPINDLE_DECREASE spindleDecrMsg = new EMC_SPINDLE_DECREASE();
  EMC_SPINDLE_CONSTANT spindleConstMsg = new EMC_SPINDLE_CONSTANT();
  EMC_TRAJ_SET_SCALE scaleMsg = new EMC_TRAJ_SET_SCALE();
  EMC_TASK_PLAN_RUN runMsg = new EMC_TASK_PLAN_RUN();
  EMC_SPINDLE_BRAKE_RELEASE brake_release_msg = new EMC_SPINDLE_BRAKE_RELEASE();
  EMC_SPINDLE_BRAKE_ENGAGE brake_engage_msg = new EMC_SPINDLE_BRAKE_ENGAGE();
  EMC_TOOL_LOAD_TOOL_TABLE load_tool_table_msg = new EMC_TOOL_LOAD_TOOL_TABLE();
  EMC_TASK_INIT task_init_msg = new EMC_TASK_INIT();

  boolean jog_started = false;

  void StartJog(int axis, int jog_type, int dir)
  {
    try 
      {
	jog_started = true;
	if(null != cmdToSend)
	  {
	    System.err.println("Don't start jog while another command pending.");
	    return;
	  }
	if(dir > 0)
	  {
	    dir = +1;
	  }
	else
	  {
	    dir = -1;
	  }
	jog_scale = 0.0;
	if(jog_speed < 0.0)
	  {
	    System.err.println("Invalid jog_speed = "+jog_speed);
	    return;
	  }
	if(null != ncStatus)
	  {
	    jog_scale =  ncStatus.motion.axis[axis].units;
	  }
	else if(null != ncStatusOld)
	  {
	    jog_scale = ncStatusOld.motion.axis[axis].units;
	  }
	else
	  {
	    System.err.println("Can't get units for jog.\n");
	    return;
	  }
	if(jog_scale < 1E-6  || jog_scale > 1E4)
	  {
	    System.err.println("Invalid jog_scale = "+jog_scale);
	    return;
	  }
	if(debug_on)
	  {
	    System.out.println("jog_scale = "+jog_scale+" units/mm");
	    System.out.println("jog_speed = "+jog_speed+" mm/s");
	    System.out.println("dir = "+dir);
	    System.out.println("jog_type = "+jog_type);
	  }
	switch(jog_type)
	  {
	  case 0:
	    jog_msg.axis = axis;
	    jog_msg.vel = jog_scale * ((double) jog_speed*dir);
	    SetCmdToSend(jog_msg,nml_emc.EMC_TASK_MODE_MANUAL);
	    break;
					
	  case 1:		 // 0.1 mm
	    incr_jog_msg.axis = axis;
	    incr_jog_msg.incr = jog_scale * 0.1;
	    incr_jog_msg.vel = jog_scale * ((double) jog_speed*dir);
	    SetCmdToSend(incr_jog_msg,nml_emc.EMC_TASK_MODE_MANUAL);
	    break;
	  case 2:		// 1.0 mm
	    incr_jog_msg.axis = axis;
	    incr_jog_msg.incr = jog_scale * 1.0;
	    incr_jog_msg.vel = jog_scale * ((double) jog_speed*dir);
	    SetCmdToSend(incr_jog_msg,nml_emc.EMC_TASK_MODE_MANUAL);
	    break;
	  case 3:		// 10.0 mm
	    incr_jog_msg.axis = axis;
	    incr_jog_msg.incr = jog_scale * 10.0;
	    incr_jog_msg.vel = jog_scale * ((double) jog_speed*dir);
	    SetCmdToSend(incr_jog_msg,nml_emc.EMC_TASK_MODE_MANUAL);
	    break;
	  case 4:		// 0.0001 inch
	    incr_jog_msg.axis = axis;
	    incr_jog_msg.incr = jog_scale * 0.00254;
	    incr_jog_msg.vel = jog_scale * ((double) jog_speed*dir);
	    SetCmdToSend(incr_jog_msg,nml_emc.EMC_TASK_MODE_MANUAL);
	    break;
	  case 5:		// 0.001 inch
	    incr_jog_msg.axis = axis;
	    incr_jog_msg.incr = jog_scale * 0.0254;
	    incr_jog_msg.vel = jog_scale * ((double) jog_speed*dir);
	    SetCmdToSend(incr_jog_msg,nml_emc.EMC_TASK_MODE_MANUAL);
	    break;
	  case 6:		// 0.01 inch
	    incr_jog_msg.axis = axis;
	    incr_jog_msg.incr = jog_scale * 0.254;
	    incr_jog_msg.vel = jog_scale * ((double) jog_speed*dir);
	    SetCmdToSend(incr_jog_msg,nml_emc.EMC_TASK_MODE_MANUAL);
	    break;
	  case 7:		// 0.1 inch
	    incr_jog_msg.axis = axis;
	    incr_jog_msg.incr = jog_scale * 2.54;
	    incr_jog_msg.vel = jog_scale * ((double) jog_speed*dir);
	    SetCmdToSend(incr_jog_msg,nml_emc.EMC_TASK_MODE_MANUAL);
	    break;
	  case 8:		// 1 inch
	    incr_jog_msg.axis = axis;
	    incr_jog_msg.incr = jog_scale * 25.4;
	    incr_jog_msg.vel = jog_scale * ((double) jog_speed*dir);
	    SetCmdToSend(incr_jog_msg,nml_emc.EMC_TASK_MODE_MANUAL);
	    break;
	  }
      }
    catch(Exception e)
      {
	e.printStackTrace();
      }
  }


  // STANDALONE APPLICATION SUPPORT
  // 	The GetParameter() method is a replacement for the getParameter() method
  // defined by Applet. This method returns the value of the specified parameter;
  // unlike the original getParameter() method, this method works when the applet
  // is run as a standalone application, as well as when run within an HTML page.
  // This method is called by GetParameters().
  //---------------------------------------------------------------------------
  String GetParameter(String strName, String args[])
  {
    String strValue = null;

    try
      {
	if(null == strName)
	  {
	    return null;
	  }

	if (args == null)
	  {
	    // Running within an HTML page, so call original getParameter().
	    //-------------------------------------------------------------------
	    strValue = getParameter(strName);
	    if(null != strValue)
	      {
		System.out.println("GetParameter: "+strName+"="+strValue);
	      }
	    return strValue;
	  }

	// Running as standalone application, so parameter values are obtained from
	// the command line. The user specifies them as follows:
	//
	//	JView NCapplet param1=<val> param2=<"val with spaces"> ...
	//-----------------------------------------------------------------------
	int    i;
	String strArg	= strName + "=";
			
	for (i = 0; i < args.length; i++)
	  {
	    if(args[i] != null)
	      {
		if(args[i].indexOf("=") < 0)
		  {
		    continue;
		  }

		if(args[i].length() > strArg.length())
		  {
		    if (strArg.equalsIgnoreCase(args[i].substring(0, strArg.length())))
		      {
			// Found matching parameter on command line, so extract its value.
			// If in double quotes, remove the quotes.
			//---------------------------------------------------------------
			strValue= args[i].substring(strArg.length());
			if (strValue.startsWith("\""))
			  {
			    strValue = strValue.substring(1);
			    if (strValue.endsWith("\""))
			      strValue = strValue.substring(0, strValue.length() - 1);
			  }
		      }
		  }
	      }
	  }
	if(null != strValue)
	  {
	    System.out.println("GetParameter: "+strName+"="+strValue);
	  }
				
      }
    catch(Exception e)
      {
	e.printStackTrace();
      }

    return strValue;
  }

  // STANDALONE APPLICATION SUPPORT
  // 	The GetParameters() method retrieves the values of each of the applet's
  // parameters and stores them in variables. This method works both when the
  // applet is run as a standalone application and when it's run within an HTML
  // page.  When the applet is run as a standalone application, this method is
  // called by the main() method, which passes it the command-line arguments.
  // When the applet is run within an HTML page, this method is called by the
  // init() method with args == null.
  //---------------------------------------------------------------------------
  void GetParameters(String args[])
  {
    try
      {
	// Query values of all Parameters
	//--------------------------------------------------------------
	String param;

	// NMLfile: URL or File Name for the NML configuration file.
	//--------------------------------------------------------------
	param = GetParameter(PARAM_NMLfile, args);
	if (param != null)
	  m_NMLfile = param;

	// InitFile: URL or File Name for the Initialization File
	//--------------------------------------------------------------
	param = GetParameter(PARAM_InitFile, args);
	if (param != null)
	  m_InitFile = param;

	// ToolTable: URL or File Name for the text file containing the tool table.
	//--------------------------------------------------------------
	param = GetParameter(PARAM_ToolTable, args);
	if (param != null)
	  m_ToolTable = param;

	// NCProgBase: Directory or Base URL where the NC programs will be stored.
	//--------------------------------------------------------------
	param = GetParameter(PARAM_NCProgBase, args);
	if (param != null)
	  {
	    m_NCProgBase = param;
	    if(m_NCProgBase.length() > 1 &&
	       !m_NCProgBase.endsWith("\\") &&
	       !m_NCProgBase.endsWith("/"))
	      {
		if(m_NCProgBase.startsWith("http:"))
		  {
		    m_NCProgBase = m_NCProgBase+"/";
		  }
		else
		  {
		    m_NCProgBase = m_NCProgBase+File.separatorChar;
		  }
	      }
	  }

	// UseColor: Allows color to displays to be just as limited as B&W
	//--------------------------------------------------------------
	param = GetParameter(PARAM_UseColor, args);
	if (param != null)
	  {
	    if(param.equals("false"))
	      {
		m_UseColor = false;
	      }
	  }

	// InterpreterDialect: Dialect used by the Part Program Interpreter
	//--------------------------------------------------------------
	param = GetParameter(PARAM_InterpreterDialect, args);
	if(param != null)
	  m_InterpreterDialect = param;

	// InchCode: G or M code used by the interpreter to indicate using inches.
	//--------------------------------------------------------------
	param = GetParameter(PARAM_InchCode, args);
	if(param != null)
	  m_InchCode = param;

	// MilliMeterCode: G or M code used by the interpreter to indicate using MilliMeters.
	//--------------------------------------------------------------
	param = GetParameter(PARAM_MilliMeterCode, args);
	if(param != null)
	  m_MilliMeterCode = param;

	// GCodeFactor: Multiplication factor used for displaying G codes, ussually 1 or 0.1
	//--------------------------------------------------------------
	param = GetParameter(PARAM_GCodeFactor, args);
	if(param != null)
	  m_GCodeFactor = Double.valueOf(param).doubleValue();


	// MCodeFactor: Multiplication factor used for displaying M codes, ussually 1 or 0.1
	//--------------------------------------------------------------
	param = GetParameter(PARAM_MCodeFactor, args);
	if(param != null)
	  m_MCodeFactor = Double.valueOf(param).doubleValue();

			
	// UserName: Default User Name used for connecting to NML, FTP, etc.
	//--------------------------------------------------------------
	param = GetParameter(PARAM_UserName, args);
	if(param != null)
	  m_UserName = param;

	// UserPasswd: Default User Passwd used for connecting to NML, FTP, etc.
	//--------------------------------------------------------------
	param = GetParameter(PARAM_UserPasswd, args);
	if(param != null)
	  m_UserPasswd = param;

	// DebugOn: URL or File Name for the NML configuration file.
	//--------------------------------------------------------------
	param = GetParameter(PARAM_DebugOn, args);
	if (param != null)
	  {
	    debug_on = Boolean.valueOf(param).booleanValue();;
	    NCappletFrame.debug_on = debug_on;
	  }


	// Assume all files stored locally can be accessed directly by the controller, so there is no need to upload them with ftp.
	//--------------------------------------------------------------
	param = GetParameter(PARAM_RunLocal, args);
	if (param != null)
	  {
	    run_local = Boolean.valueOf(param).booleanValue();;
	  }

      }
    catch(Exception e)
      {
	e.printStackTrace();
      }
  }

public String []CreateArgs()
  {
    String args[] = new String[5];

    try
      {
	args[0] = "NMLfile="+m_NMLfile;
	args[1] = "InitFile="+m_InitFile;
	args[2] = "ToolTable="+m_ToolTable;
	args[3] = "NCProgBase="+m_NCProgBase;
	args[4] = "UseColor="+m_UseColor;
      }
    catch(Exception e)
      {
	e.printStackTrace();
      }
    return args;
  }

   public static final String ident = "$Id: NCapplet.java,v 1.1 1999/01/21 13:36:17 shackle Exp shackle $";


  // STANDALONE APPLICATION SUPPORT
  // 	The main() method acts as the applet's entry point when it is run
  // as a standalone application. It is ignored if the applet is run from
  // within an HTML page.
  //--------------------------------------------------------------------------
public static void main(String args[])
  {
    String version = "   ";
     
    try
    {
      int version_index = ident.indexOf(",v")+2;
      if(version_index >0)
      {
	int space_index = ident.indexOf(" ", version_index+6);
	version = ident.substring(version_index, space_index);
      }
    }
    catch(Exception e)
      {
	e.printStackTrace();
      }
    System.out.println("");
    System.out.println(" *****************************************");    
    System.out.println(" *** Java Graphical User Interface     ***");
    System.out.println(" *** Version: "+version+"         ***");
    System.out.println(" ***         for the                   ***");
    System.out.println(" *** Enhanced Machine Controller       ***");
    System.out.println(" *****************************************");
    System.out.println("");
    
    if(args.length > 0)
      {
	String first_arg = args[0].toUpperCase();
	//System.out.println("first_arg = "+first_arg);
	if(first_arg.indexOf("HELP") > -1 ||
	   first_arg.indexOf('?') > -1)
	  {
	    try
	      {
		NCapplet temp_applet = new NCapplet();
		System.out.println(temp_applet.getAppletInfo());
		String param_info[][] = temp_applet.getParameterInfo();
		System.out.println("Usage: [Parameter=value]");
		System.out.println("Parameter \tType \tDescription");
		for(int i = 0; i < param_info.length; i++)
		  {
		    for(int ii = 0; ii < param_info[i].length; ii++)
		      {
			System.out.print(param_info[i][ii]+" \t");
		      }
		    System.out.println("");
		  }
		//Thread.sleep(5000);
	      }
	    catch(Exception e)
	      {
		e.printStackTrace();
	      }
	    System.exit(0);
	  }
	else if(args[0].equalsIgnoreCase("-nml") && args.length > 1)
	  {
	    m_NMLfile = args[1];
	    System.out.println("Using "+m_NMLfile+" as the NML configuration file.");
	    
	  }
	for(int i = 0; i < args.length; i++)
	  {
	    String argCaps = args[i].toUpperCase();
	    System.out.println("argCaps = "+argCaps);
	    if(argCaps.indexOf("DEBUG") >= 0 )
	      {
		debug_on = true;
		System.out.println("Debug Mode ON.");
	      }
	  }
      }

    CreateNewWindow(args, true);
  }

public static void CreateNewWindow(String args[], boolean stand_alone)
  {
    try
      {
	if(debug_on)
	  {
	    System.out.println("Create new Frame");
	  }
	// Create Toplevel Window to contain applet NCapplet
	//-----------------------------------------------------------------
	NCappletFrame frame = new NCappletFrame("NCapplet",null);
	NCappletFrame.in_an_applet = !stand_alone;

	int frame_width = 775;
	int frame_height = 575;
	if(debug_on)
	  {
	    System.out.println("Get Screensize");
	  }
	try
	  {
	    Toolkit tk = frame.getToolkit();
	    if(null != tk)
	      {
		Dimension d = tk.getScreenSize();
		if(null != d)
		  {
		    frame_width = d.width - 35;
		    frame_height = d.height -35;
		  }
	      }
	  }
	catch(Exception e)
	  {
	    e.printStackTrace();
	  }
	if(frame_width > 1075)
	  {
	    frame_width = 1075;
	  }
	if(frame_height > 775)
	  {
	    frame_height = 775;
	  }	
	
	
	frame.hide();
	frame.resize(frame_width, frame_height);
	Point p = frame.getLocation();
	Insets is = frame.insets();
	if(is.left < 10)
	  {
	    is.left = 10;
	  }
	if(is.top < 10)
	  {
	    is.top = 10;
	  }
	if(p.x < is.left || p.y < is.top)
	  {
	    p.x = is.left+1;
	    p.y = is.top+1;
	    frame.setLocation(p);
	  }
	

	// The following code starts the applet running within the frame window.
	// It also calls GetParameters() to retrieve parameter values from the
	// command line, and sets m_fStandAlone to true to prevent init() from
	// trying to get them from the HTML page.
	//----------------------------------------------------------------------
	if(debug_on)
	  {
	    System.out.println("Create new Applet");
	  }
	NCapplet applet_NCapplet = new NCapplet();
	frame.innerApplet =   applet_NCapplet;
	applet_NCapplet.in_resizable_window = true;
	if(stand_alone)
	  {
	    applet_NCapplet.m_fStandAlone = true;
	    applet_NCapplet.GetParameters(args);
	  }
	frame.resizeInnerApplet();

	frame.add("Center", applet_NCapplet);
	
	if(debug_on)
	  {
	    System.out.println("Initialize Applet");
	  }
	applet_NCapplet.init();
	if(debug_on)
	  {
	    System.out.println("Show Frame");
	  }
	frame.show();
	if(debug_on)
	  {
	    System.out.println("Start  Applet");
	  }
	applet_NCapplet.start();
      }
    catch(Exception e)
      {
	e.printStackTrace();
      }
  }

  // NCapplet Class Constructor
  //--------------------------------------------------------------------------
public NCapplet()
  {
    nc_applet_count++;
  }

  // APPLET INFO SUPPORT:
  //		The getAppletInfo() method returns a string describing the applet's
  // author, copyright date, or miscellaneous information.
  //--------------------------------------------------------------------------
public String getAppletInfo()
  {
    return "Name: NCapplet\r\n" +
      "Author: Will Shackleford\r\n" +
      "Created with Microsoft Visual J++ Version 1.0\r\n" +
      "\r\n" +
      "";
  }

  // PARAMETER SUPPORT
  //		The getParameterInfo() method returns an array of strings describing
  // the parameters understood by this applet.
  //
  // NCapplet Parameter Information:
  //  { "Name", "Type", "Description" },
  //--------------------------------------------------------------------------
public String[][] getParameterInfo()
  {
    String[][] info =
    {
      { PARAM_NMLfile, "String", "URL or File Name for the NML configuration file." },
      { PARAM_InitFile, "String", "URL or File Name for the Initialization File" },
      { PARAM_ToolTable, "String", "URL or File Name for the text file containing the tool table." },
      { PARAM_NCProgBase, "String", "Directory or Base URL where the NC programs will be stored." },
      { PARAM_InterpreterDialect, "String", "Dialect used by the Part Program Interpreter." },
      { PARAM_InchCode, "String", "G or M code used by the interpreter to indicate using inches." },
      { PARAM_MilliMeterCode, "String", "G or M code used by the interpreter to indicate using MilliMeters." },
      { PARAM_GCodeFactor, "double", "Multiplication factor used for displaying G codes, ussually 1 or 0.1" },
      { PARAM_MCodeFactor, "double", "Multiplication factor used for displaying M codes, ussually 1 or 0.1" }	,
      { PARAM_UserName, "String", "Default User Name used for connecting to NML, FTP etc." },
      { PARAM_UserPasswd, "String", "Default User Passwd used for connecting to NML, FTP etc." },
      { PARAM_DebugOn, "boolean", "Turn on additional debug messages. (Printed to stdout/JavaConsole)" },
      { PARAM_RunLocal, "boolean", "Assume all local files can be accessed directly by the controller, so there is no need to upload them." }
    };
    return info;		
  }

  RCS_CMD_MSG cmdToSend = null;
  int mode_for_command = -1;

public void SetCmdToSend(RCS_CMD_MSG cmdMsg, int mode)
  {
    if(null != cmdToSend)
      {
	System.err.println("Attempt to send 2 commands in the same cycle. "+cmdMsg.type + " and "+ cmdToSend.type);
      }
    cmdToSend = cmdMsg;
    mode_for_command = mode;
  }


  long start_waitfordone_millis = System.currentTimeMillis();
  boolean WaitForDoneNeeded = false;
  double WaitForDoneTimeout = 5.0;
  
  public boolean IsDone() 
  {
    long timeout_millis = (long) (WaitForDoneTimeout*1000.0);
    try
      {
	ncStatus = (EMC_STAT) NCStatusChannel.read();
      }
    catch(NMLException e)
      {
	e.printStackTrace();
	is_connected = false;
	connectedCheckbox.setState(false);
	Alert("Can't read NC Status NML Channel.\n"+e.getMessage());
	WaitForDoneNeeded = false;
	reconnect_needed = true;
	consecutive_nulls = 0;
	return false;
      }
    if(null != ncStatus)
      {
	consecutive_nulls = 0;
	if((
	    ncStatus.status == nml_emc.RCS_DONE ||
	    ncStatus.status == nml_emc.UNINITIALIZED_STATUS )  &&
	   ncStatus.echo_serial_number == nc_serial_number)
	  {
	    start_waitfordone_millis = System.currentTimeMillis();
	    WaitForDoneNeeded = false;
	    return true;
	  }
      }
    if(System.currentTimeMillis() - start_waitfordone_millis > timeout_millis)
      {
	System.err.println("WaitForDone Timed-Out");
	start_waitfordone_millis = System.currentTimeMillis();
	WaitForDoneNeeded = false;
	return true;
      }
    return false;
  }
	
  

public void SendCommand()
  {
    int i = 0;
    try
      {
	if(null == cmdToSend)
	  {
	    return;
	  }
	//rcs.nml.NMLFormatConverterBase.debug_on = true;
	if(null == cmdToSend)
	  {
	    return;
	  }
	try
	  {
	    if(autoSetModeCheckbox.getState() && null != NCStatusChannel && mode_for_command > 0)
	      {
		if(null == ncStatus)
		  {
		    ncStatus = ncStatusOld;
		  }
		if(null != ncStatus )
		  {
		  setmode:				{	
		    if(mode_for_command != ncStatus.task.mode)
		      {
			if(debug_on)
			  {
			    System.out.println("Setting mode to "+mode_for_command);
			  }
			modeMsg.mode = mode_for_command;
			nc_serial_number++;
			modeMsg.serial_number = nc_serial_number;
			NCCommandChannel.write(modeMsg);
			for( i = 0; i < 10; i++)
			  {
			    try
			      {
				ncStatus = (EMC_STAT) NCStatusChannel.read();
			      }
			    catch(NMLException e)
			      {
				e.printStackTrace();
				consecutive_nulls = 0;
				is_connected = false;
				connectedCheckbox.setState(false);
				Alert("Can't read NC Status NML Channel.\n"+e.getMessage());
				break setmode;
			      }
			    if(null != ncStatus)
			      {
				consecutive_nulls = 0;
				if(ncStatus.task.mode == mode_for_command)
				  {
				    break setmode;
				  }
				if(ncStatus.echo_serial_number == nc_serial_number)
				  {
				    break setmode;
				  }
			      }
			    Thread.sleep(100);
			  }
		      }
		  }
		  if(debug_on)
		    {
		      System.out.println("Mode changed after "+i+" cycles.");
		    }
		  first_stat_display = true;
		  }
		if(ncStatus == ncStatusOld)
		  {
		    ncStatus = null;
		  }
		else
		  {
		    ncStatusOld.task.mode = ncStatus.task.mode;
		    ncStatusOld.echo_serial_number = ncStatus.echo_serial_number;
		  }
	      }
	  }
	catch(Exception e)
	  {
	    e.printStackTrace();
	  }
	nc_serial_number++;
	cmdToSend.serial_number = nc_serial_number;
	NCCommandChannel.write(cmdToSend);	
      }
    catch(Exception e)
      {
	e.printStackTrace();
      }
    //rcs.nml.NMLFormatConverterBase.debug_on = false;
    cmdToSend = null;
    mode_for_command = -1;

  }



  // Called any time the user presses a button or uses a control.
public boolean  action(Event  evt, Object  what)
  {
    try
      {
	if(inside_init || loading_tool_table)
	  {
	    return false;
	  }

	if(evt.target ==  readErrlogCheckbox)
	  {
	    read_errlog =  readErrlogCheckbox.getState();
	  }

	//NMLConnection.write_debug_on = true;
	if(evt.target == connectedCheckbox)
	  {
	    boolean new_is_connected = connectedCheckbox.getState();
	    if(new_is_connected != is_connected)
	      {
		is_connected = new_is_connected;
		if(is_connected)
		  {
		    InitializeNML();
		  }
		else
		  {
		    DisconnectNML();
		  }
	      }
	  }

	if(evt.target == NMLfileTextField)
	  {
	    m_NMLfile = NMLfileTextField.getText();
	  }
	
	if(!NMLInitialized)
	  {
	    return false;
	  }

	if(evt.target == relativePositionCheckbox)
	  {
	    relative_position = relativePositionCheckbox.getState();
	    XLocalOffsetCheckbox.setState(false);
	    x_local_offset = 0;
	    XLocalOffsetCheckbox.setLabel("Offset: "+x_local_offset);
	    YLocalOffsetCheckbox.setState(false);
	    y_local_offset = 0;
	    YLocalOffsetCheckbox.setLabel("Offset: "+y_local_offset);
	    ZLocalOffsetCheckbox.setState(false);
	    z_local_offset = 0;
	    ZLocalOffsetCheckbox.setLabel("Offset: "+z_local_offset);
	  }

	if(evt.target == spindleBrakeCheckbox)
	  {
	    boolean engage_brake = spindleBrakeCheckbox.getState();
	    if(engage_brake)
	      {
		SetCmdToSend(brake_engage_msg, -1);
	      }
	    else
	      {
		SetCmdToSend(brake_release_msg, -1);
	      }
	  }

	if(evt.target ==  mmCheckbox)
	   {
	     if(!mmCheckbox.getState())
	       {
		 unit_type = INCH_UNITS;
		 jogSpeedLabel.setText("Jog Speed: "+FormatDouble(((double)jog_speed*MILLIMETERS_TO_INCHES),7)+" inch/s");
	       }
	     else
	       {
		  unit_type = MILLIMETER_UNITS;
		  jogSpeedLabel.setText("Jog Speed: "+FormatDouble(((double)jog_speed),7)+" mm/s");
	       }
	   }

	if(evt.target == memCleanCheckButton)
	  {
	    System.out.println("Memory state before garbage collection:");
	    Runtime rt = Runtime.getRuntime();
	    System.out.println("\tTotal Memory: "+rt.totalMemory());
	    System.out.println("\tFree Memory: "+rt.freeMemory());
	    long start_time = System.currentTimeMillis();
	    rt.runFinalization();
	    rt.gc();
	    long gc_time = System.currentTimeMillis() - start_time;
	    System.out.println("Garbage collection took "+gc_time+" ms.");
	    System.out.println("Memory state after garbage collection:");
	    System.out.println("\tTotal Memory: "+rt.totalMemory());
	    System.out.println("\tFree Memory: "+rt.freeMemory());
	  }
	    

	if(evt.target ==  inchesCheckbox)
	   {
	     if(inchesCheckbox.getState())
	       {
		 unit_type = INCH_UNITS;
		 jogSpeedLabel.setText("Jog Speed: "+FormatDouble(((double)jog_speed*MILLIMETERS_TO_INCHES),7)+" inch/s");
	       }
	     else
	       {
		  unit_type = MILLIMETER_UNITS;
		  jogSpeedLabel.setText("Jog Speed: "+FormatDouble(((double)jog_speed),7)+" mm/s");
	       }
	   }
	if(evt.target == (newWindowButton))
	  {
	    CreateNewWindow(CreateArgs(), m_fStandAlone);
	    return true;
	  }
	if(evt.target == (abortButton))
	  {
	    nc_serial_number++;
	    abortMsg.serial_number = nc_serial_number;
	    cmdToSend = null;
	    NCCommandChannel.write(abortMsg);
	    return true;
	  }
	if(evt.target == initButton)
	  {
	    initQueryDialog = Query("Re-initialize Controller?");
	  }
	if(evt.target == (positionButton))
	  {
	    choiceLayout.show(choicePanel, "position");
	    titleBarLabel.setText(". . .  NC Position  . . .");
	    choice_layout_selection = "position";
	    return true;
	  }
	if(evt.target == (programButton))
	  {
	    choiceLayout.show(choicePanel, "program");
	    titleBarLabel.setText(". . .  NC Program  . . .");
	    choice_layout_selection = "program";
	    return true;
	  }
	if(evt.target == (loadProgramButton))
	  {
	    load_program_requested = true;
	    return true;
	  }
	if(evt.target == (toolTableLoadButton))
	  {
	    String toolTableFile = toolTableTextField.getText();
	    toolTableFile.getBytes(0, toolTableFile.length(),load_tool_table_msg.file, 0);
	    load_tool_table_msg.file[toolTableFile.length()] = 0;
	    nc_serial_number++;
	    load_tool_table_msg.serial_number = nc_serial_number;
	    NCCommandChannel.write(load_tool_table_msg);
	    WaitForDoneTimeout = 5.0;
	    start_waitfordone_millis = System.currentTimeMillis();
	    WaitForDoneNeeded = true;
	    load_tool_table_needed = true;
	    return true;
	  }
	if(evt.target == (browseLocalButton))
	  {
	    browse_local_requested = true;
	    return true;
	  }
	if(evt.target == (browseRemoteButton))
	  {
	    browse_remote_requested = true;
	    return true;
	  }
	if(evt.target == (runButton))
	  {
	    RunProgram(programTextField.getText());
	    return true;
	  }

	if(evt.target == (mdiExecField) || 
	   evt.target == (mdiExecButton) )
	  {
	    String command_string = mdiExecField.getText();
	    if(null != command_string)
	      {
		if(command_string.length() > 0)
		  {
		    command_string.getBytes(0, command_string.length(), exec_msg.command,0);
		    exec_msg.command[command_string.length()] = 0;
		    SetCmdToSend(exec_msg, nml_emc.EMC_TASK_MODE_MDI);
		    if(null != mdiOldCommandsArea)
		      {
			int old_text_length = mdiOldCommandsArea.getText().length();
			if(old_text_length > 4096)
			  {
			    mdiOldCommandsArea.replaceText("",0,512);
			  }
			mdiOldCommandsArea.appendText(command_string+newline);
		      }
		    if(null != old_mdi_commands)
		      {
			old_mdi_commands.addElement(command_string);
			current_mdi_command_index = old_mdi_commands.size();
			while(current_mdi_command_index > 100)
			  {
			    old_mdi_commands.removeElementAt(0);
			    current_mdi_command_index--;
			  }
		      }
		    mdiExecField.setText("");
		  }
	      }
	    return true;
	  }
				
	if(evt.target == (toolTableButton))
	  {
	    choiceLayout.show(choicePanel, "tooltable");
	    titleBarLabel.setText(". . .  NC Tool Table  . . .");
	    choice_layout_selection = "tooltable";
	    
	    LoadToolTable();
	    return true;
	  }
	if(evt.target == (cpanelButton))
	  {
	    choiceLayout.show(choicePanel, "cpanel");
	    titleBarLabel.setText(". . .  NC Control Panel  . . .");
	    choice_layout_selection = "cpanel";
	    return true;
	  }
	if(evt.target == (errlogButton))
	  {
	    choiceLayout.show(choicePanel, "errlog");
	    titleBarLabel.setText(". . .  NC Error Log  . . .");
	    errlogStatusLabel.setBackground(Color.lightGray);
	    errlogStatusLabel.setText(num_errors+" errors");
	    num_new_errors = 0;
	    choice_layout_selection = "errlog";
	    return true;
	  }
	if(evt.target == (clearErrlogButton))
	  {
	    num_errors = 0;
	    errlogTextArea.setText("");
	    errlogStatusLabel.setBackground(Color.lightGray);
	    errlogStatusLabel.setText("0 errors");
	    return true;
	  }
	if(evt.target == (haltButton))
	  {
	    if(null != NCCommandChannel)
	      {
		SetCmdToSend(haltMsg, -1);
	      }
	    return true;
	  }
	if(evt.target == (holdButton))
	  {
	    if(null != NCCommandChannel)
	      {
		SetCmdToSend(pauseMsg,-1);
	      }
	    return true;
	  }
	if(evt.target == (resumeButton))
	  {
	    if(null != NCCommandChannel)
	      {
		SetCmdToSend(resumeMsg,-1);
	      }
	  }
	if(evt.target == (singleStepButton))
	  {
	    if(null != NCCommandChannel)
	      {
		SetCmdToSend(stepMsg,nml_emc.EMC_TASK_MODE_AUTO);
	      }
	    return true;
	  }
	if(evt.target == (estopButton))
	  {
	    if(null != NCCommandChannel)
	      {
		stateMsg.state = nml_emc.EMC_TASK_STATE_ESTOP;
		SetCmdToSend(stateMsg, -1);
	      }
	    estop_queried = true;
	    machine_off_queried = true;
	    return true;
	  }
	if(evt.target == (estopResetButton))
	  {
	    if(null != NCCommandChannel)
	      {
		stateMsg.state = nml_emc.EMC_TASK_STATE_ESTOP_RESET;
		SetCmdToSend(stateMsg,-1);
	      }
	    estop_queried = true;
	    machine_off_queried = true;
	    return true;
	  }
	if(evt.target == (machineOnButton))
	  {
	    if(null != NCCommandChannel)
	      {
		stateMsg.state = nml_emc.EMC_TASK_STATE_ON;
		SetCmdToSend(stateMsg,-1);
	      }
	    return true;
	  }
	if(evt.target == (machineOffButton))
	  {
	    if(null != NCCommandChannel)
	      {
		stateMsg.state = nml_emc.EMC_TASK_STATE_OFF;
		SetCmdToSend(stateMsg,-1);
	      }
	    estop_queried = true;
	    machine_off_queried = true;
	    return true;
	  }
	if(evt.target == (autoButton))
	  {
	    if(null != NCCommandChannel)
	      {
		modeMsg.mode = nml_emc.EMC_TASK_MODE_AUTO;
		nc_serial_number++;
		modeMsg.serial_number = nc_serial_number;
		cmdToSend = null;
		NCCommandChannel.write(modeMsg);
	      }
	    return true;
	  }
	if(evt.target == (mdiButton))
	  {
	    if(null != NCCommandChannel)
	      {
		modeMsg.mode = nml_emc.EMC_TASK_MODE_MDI;
		nc_serial_number++;
		modeMsg.serial_number = nc_serial_number;
		cmdToSend = null;
		NCCommandChannel.write(modeMsg);
	      }
	    return true;
	  }
	if(evt.target == (manualButton))
	  {
	    if(null != NCCommandChannel)
	      {
		modeMsg.mode = nml_emc.EMC_TASK_MODE_MANUAL;
		nc_serial_number++;
		modeMsg.serial_number = nc_serial_number;
		cmdToSend = null;
		NCCommandChannel.write(modeMsg);
	      }
	    return true;
	  }
	if(evt.target == (spindleCCWButton))
	  {
	    if(null != NCCommandChannel)
	      {
		spindleOnMsg.speed = -5;
		SetCmdToSend(spindleOnMsg,-1);
	      }
	    return true;
	  }
	if(evt.target == (spindleOffButton))
	  {
	    if(null != NCCommandChannel)
	      {
		SetCmdToSend(spindleOffMsg,-1);
	      }
	    return true;
	  }
	if(evt.target == (spindleCWButton))
	  {
	    if(null != NCCommandChannel)
	      {
		spindleOnMsg.speed = 5;
		SetCmdToSend(spindleOnMsg,-1);
	      }
	    return true;
	  }
	if(evt.target == (spindleIncrButton))
	  {
	    if(null != NCCommandChannel)
	      {
		if(spindleIncrButton.is_down)
		  {
		    SetCmdToSend(spindleIncrMsg, -1);
		  }
		else
		  {
		    SetCmdToSend(spindleConstMsg, -1);
		  }
	      }
	    return true;
	  }
	if(evt.target == (spindleDecrButton))
	  {
	    if(null != NCCommandChannel)
	      {
		if(spindleDecrButton.is_down)
		  {
		    SetCmdToSend(spindleDecrMsg, -1);
		  }
		else
		  {
		    SetCmdToSend(spindleConstMsg, -1);
		  }
	      }
	    return true;
	  }
	if(evt.target == (XJogPlusButton))
	  {
	    if(XJogPlusButton.is_down)
	      {
		int jog_type = jogTypeChoice.getSelectedIndex();
		StartJog(0,jog_type, +1);
	      }
	    else
	      {
		nc_serial_number++;
		axis_stop_msg.serial_number = nc_serial_number;
		axis_stop_msg.axis = 0;
		cmdToSend = null;
		NCCommandChannel.write(axis_stop_msg);
		//SetCmdToSend(axis_stop_msg,nml_emc.EMC_TASK_MODE_MANUAL);
		jog_started = false;
	      }	
	    return true;
	  }
	if(evt.target == (XJogMinusButton))
	  {
	    if(XJogMinusButton.is_down)
	      {
		int jog_type = jogTypeChoice.getSelectedIndex();
		StartJog(0,jog_type, -1);
	      }
	    else
	      {
		nc_serial_number++;
		axis_stop_msg.serial_number = nc_serial_number;
		axis_stop_msg.axis = 0;
		cmdToSend = null;
		NCCommandChannel.write(axis_stop_msg);
		//SetCmdToSend(axis_stop_msg,nml_emc.EMC_TASK_MODE_MANUAL);
		jog_started = false;
	      }	
	    return true;
	  }
	if(evt.target == (XHomeButton))
	  {
	    if(null != NCCommandChannel)
	      {
		homeMsg.axis = 0;
		SetCmdToSend(homeMsg,nml_emc.EMC_TASK_MODE_MANUAL);
	      }
	    return true;
	  }

	if(evt.target == XEnableCheckbox)
	  {
	    boolean enable_axis = XEnableCheckbox.getState();
	    if(enable_axis)
	      {
		axis_enable_msg.axis = 0;
		SetCmdToSend(axis_enable_msg, -1);
	      }
	    else
	      {
		axis_disable_msg.axis = 0;
		SetCmdToSend(axis_disable_msg, -1);
	      }
	  }

	if(evt.target == XLocalOffsetCheckbox)
	  {
	    boolean set_offset = XLocalOffsetCheckbox.getState();
	    if(set_offset)
	      {
		x_local_offset = ncStatusOld.motion.traj.position.tran.x;
	      }
	    else
	      {
		x_local_offset = 0;
	      }
	    XLocalOffsetCheckbox.setLabel("Offset:"+x_local_offset);
	  }

			
	if(evt.target == (YJogPlusButton))
	  {
	    if(YJogPlusButton.is_down)
	      {
		int jog_type = jogTypeChoice.getSelectedIndex();
		StartJog(1,jog_type, +1);
	      }
	    else
	      {
		nc_serial_number++;
		axis_stop_msg.serial_number = nc_serial_number;
		axis_stop_msg.axis = 1;
		cmdToSend = null;
		NCCommandChannel.write(axis_stop_msg);
		//SetCmdToSend(axis_stop_msg,nml_emc.EMC_TASK_MODE_MANUAL);
		jog_started = false;
	      }	
	    return true;
	  }
	if(evt.target == (YJogMinusButton))
	  {
	    if(YJogMinusButton.is_down)
	      {
		int jog_type = jogTypeChoice.getSelectedIndex();
		StartJog(1,jog_type, -1);
	      }
	    else
	      {
		nc_serial_number++;
		axis_stop_msg.serial_number = nc_serial_number;
		axis_stop_msg.axis = 1;
		cmdToSend = null;
		NCCommandChannel.write(axis_stop_msg);
		//SetCmdToSend(axis_stop_msg,nml_emc.EMC_TASK_MODE_MANUAL);
		jog_started = false;
	      }	
	    return true;
	  }
	if(evt.target == (YHomeButton))
	  {
	    if(null != NCCommandChannel)
	      {
		homeMsg.axis = 1;
		SetCmdToSend(homeMsg,nml_emc.EMC_TASK_MODE_MANUAL);
	      }
	    return true;
	  }

	if(evt.target == YEnableCheckbox)
	  {
	    boolean enable_axis = YEnableCheckbox.getState();
	    if(enable_axis)
	      {
		axis_enable_msg.axis = 1;
		SetCmdToSend(axis_enable_msg, -1);
	      }
	    else
	      {
		axis_disable_msg.axis = 1;
		SetCmdToSend(axis_disable_msg, -1);
	      }
	  }

	if(evt.target == YLocalOffsetCheckbox)
	  {
	    boolean set_offset = YLocalOffsetCheckbox.getState();
	    if(set_offset)
	      {
		y_local_offset = ncStatusOld.motion.traj.position.tran.y;
	      }
	    else
	      {
		y_local_offset = 0;
	      }
	    YLocalOffsetCheckbox.setLabel("Offset:"+y_local_offset);
	  }

	if(evt.target == (ZJogPlusButton))
	  {
	    if(ZJogPlusButton.is_down)
	     {
		int jog_type = jogTypeChoice.getSelectedIndex();
		StartJog(2,jog_type, +1);
	      }
	    else
	      {
		nc_serial_number++;
		axis_stop_msg.serial_number = nc_serial_number;
		axis_stop_msg.axis = 2;
		cmdToSend = null;
		NCCommandChannel.write(axis_stop_msg);
		//SetCmdToSend(axis_stop_msg,nml_emc.EMC_TASK_MODE_MANUAL);
		jog_started = false;
	      }	
	    return true;
	  }
	if(evt.target == (ZJogMinusButton))
	  {
	    if(ZJogMinusButton.is_down)
	      {
		int jog_type = jogTypeChoice.getSelectedIndex();
		StartJog(2,jog_type, -1);
	      }
	    else
	      {
		nc_serial_number++;
		axis_stop_msg.serial_number = nc_serial_number;
		axis_stop_msg.axis = 2;
		cmdToSend = null;
		NCCommandChannel.write(axis_stop_msg);
		//SetCmdToSend(axis_stop_msg,nml_emc.EMC_TASK_MODE_MANUAL);
		jog_started = false;
	      }	
	    return true;
	  }
	if(evt.target == (ZHomeButton))
	  {
	    if(null != NCCommandChannel)
	      {
		homeMsg.axis = 2;
		SetCmdToSend(homeMsg,nml_emc.EMC_TASK_MODE_MANUAL);
	      }
	    return true;
	  }

	if(evt.target == ZEnableCheckbox)
	  {
	    boolean enable_axis = ZEnableCheckbox.getState();
	    if(enable_axis)
	      {
		axis_enable_msg.axis = 2;
		SetCmdToSend(axis_enable_msg, nml_emc.EMC_TASK_MODE_MANUAL);
	      }
	    else
	      {
		axis_disable_msg.axis = 2;
		SetCmdToSend(axis_disable_msg, nml_emc.EMC_TASK_MODE_MANUAL);
	      }
	  }
	
	if(evt.target == ZLocalOffsetCheckbox)
	  {
	    boolean set_offset = ZLocalOffsetCheckbox.getState();
	    if(set_offset)
	      {
		z_local_offset = ncStatusOld.motion.traj.position.tran.z;
	      }
	    else
	      {
		z_local_offset = 0;
	      }
	    ZLocalOffsetCheckbox.setLabel("Offset:"+z_local_offset);
	  }


      }
    catch(Exception e)
      {
	e.printStackTrace();
      }
    return super.action(evt,what);
  }

  boolean loading_tool_table = false;
  boolean load_tool_table_needed = false;
  void LoadToolTable()
  {
    try
      {
	int i = 0;
	loading_tool_table = true;
	if(null == NCStatusChannel || null == toolTableList)
	  {
	    return;
	  }
	while(i < 20 && ncStatus == null)
	  {
	    ncStatus = (EMC_STAT) NCStatusChannel.read();
	    Thread.sleep(100);
	  }
	if(null == ncStatus)
	  {
	    loading_tool_table = false;
	    return;
	  }
	consecutive_nulls = 0;
	toolTableList.clear();
	System.out.println("Loading tool table . . .");
	toolTableList.addItem("Position   ID         Length       Diameter\n");
	System.out.println("Loading tool table . . .");
	for(i = 0;  i < nml_emc.CANON_TOOL_MAX; i++)
	  {
	    while(i < 5 && ncStatus == null)
	      {
		ncStatus = (EMC_STAT) NCStatusChannel.read();
		Thread.sleep(100);
	      }
	    if(null == ncStatus)
	      {
		continue;
	      }
	    if(null == ncStatus.io.tool.toolTable[i])
	      {
		System.err.println("Null entry in tool table at position "+i);
		continue;
	      }
	    int id = ncStatus.io.tool.toolTable[i].id;
	    double length =  ncStatus.io.tool.toolTable[i].length;
	    double diameter =  ncStatus.io.tool.toolTable[i].diameter;
	    String str = " "+i+"          "+id+"         "+length+"         "+diameter;
	    toolTableList.addItem(str);
	    System.out.println(str);
	  }
      }
    catch(Exception e)
      {
	e.printStackTrace();
      }
    loading_tool_table = false;
    load_tool_table_needed = false;
  }
	
    

public boolean handleEvent(Event  evt)
  {
    try
      {
	if(inside_init || loading_tool_table || !NMLInitialized)
	  {
	    return false;
	  }

	if(evt.target == statusPanel || evt.target == mdiOldCommandsArea)
	  {
	    if(num_new_errors > 0)
	      {
		errlogStatusLabel.setBackground(Color.lightGray);
		errlogStatusLabel.setText(num_errors+" errors");
		num_new_errors = 0;
		repaint();
	      }
	  }

	if(evt.target == cycleTimeScrollbar)
	  {
	    int cycle_time_millis = cycleTimeScrollbar.getValue();
	    cycle_time = ((double) cycle_time_millis)/1000.0;
	    cycleTimeScrollbar.setValue((int) (cycle_time*1000.0));
	    return true;
	  }

	if(evt.target == mdiExecField &&
	   evt.id == Event.KEY_ACTION &&
	   null != old_mdi_commands)
	  {
	    if(evt.key == Event.UP && current_mdi_command_index > 0)
	      {
		current_mdi_command_index--;
		String temp = (String) old_mdi_commands.elementAt(current_mdi_command_index);
		if(null != temp)
		  {
		    mdiExecField.setText(temp);
		  }
		return true;
	      }
	    if(evt.key == Event.DOWN && current_mdi_command_index < old_mdi_commands.size())
	      {
		current_mdi_command_index++;
		String temp = (String) old_mdi_commands.elementAt(current_mdi_command_index);
		if(null != temp)
		  {
		    mdiExecField.setText(temp);
		  }
		return true;
	      }
	  }
	if(evt.target == (jogSpeedSlider))
	  {
	    jog_speed = jogSpeedSlider.getValue();
	    jogSpeedSlider.setValue(jog_speed);
	    if(debug_on)
	      {
		System.out.println("jog_speed = "+jog_speed+" mm/s");
	      }
	    if(unit_type == INCH_UNITS)
	      {
	    jogSpeedLabel.setText("Jog Speed: "+FormatDouble(((double)jog_speed*MILLIMETERS_TO_INCHES),7)+" inch/s");
	      }
	    else
	      {
		jogSpeedLabel.setText("Jog Speed: "+FormatDouble(((double)jog_speed),7)+" mm/s");
	      }
				      
	    return true;
	  }
	if(evt.target == (feedrateOverrideSlider))
	  {
	    if(null != NCCommandChannel)
	      {
		scaleMsg.scale = ((double) feedrateOverrideSlider.getValue()) / 100.0;
		nc_serial_number++;
		scaleMsg.serial_number = nc_serial_number;
		cmdToSend = null;
		NCCommandChannel.write(scaleMsg);
		feedrateOverrideSlider.setValue((int) (scaleMsg.scale*100));
	      }
	    return true;
	  }
	/* if(evt.target == (spindleOverrideSlider))
	  {
	    if(null != NCCommandChannel)
	      {
		NML_IO_SET_SPEED_OVERRIDE overrideMsg = new NML_IO_SET_SPEED_OVERRIDE();
		overrideMsg.override = ((double) spindleOverrideSlider.getValue()) / 100.0;
		nc_serial_number++;
		overrideMsg.serial_number = nc_serial_number;
		cmdToSend = null;
		NCCommandChannel.write(overrideMsg);
		spindleOverrideSlider.setValue((int) (overrideMsg.override*100));
	      }
	    return true;
	  } */
      }
    catch(Exception e)
      {
	e.printStackTrace();
      }
    return super.handleEvent(evt);
  }

private void CheckForColor()
  {
    try
      {
	java.awt.Toolkit tk = 	java.awt.Toolkit.getDefaultToolkit();
	if(tk == null)
	  {
	    return;
	  }
	java.awt.image.ColorModel cm = tk.getColorModel();
	if(cm == null)
	  {
	    return;
	  }
	if(cm.getPixelSize() < 2)
	  {
	    m_UseColor = false;
	  }
      }
    catch(Exception e)
      {
	e.printStackTrace();
      }
  }

  boolean InsideResizableFrame()
  {
    Frame frm = null;
    Container container = null;
    try
      {
	container = getParent();
	if(debug_on)
	  {
	    System.out.println(String.valueOf(container));
	  }
	frm = (Frame) container;
      }
    catch(ClassCastException cce)
      {
	return m_fStandAlone;
      }
    catch(Exception e)
      {
	e.printStackTrace();
	return m_fStandAlone;
      }
    if(null == frm)
      {
	return m_fStandAlone;
      }
    return frm.isResizable();
  }

  boolean in_resizable_window = false;

  int old_width = 0;
  int old_height = 0;

public void resize(int new_width, int new_height)
  {
    super.resize(new_width,new_height);
    try
      {
	if(inside_init)
	  {
	    return;
	  }
	if(debug_on)
	  {
	    System.out.println("InsideResizableFrame() = "+InsideResizableFrame());
	    System.out.println("new_width = "+new_width);
	    System.out.println("new_height = "+new_height);
	    System.out.println("m_fStandAlone = "+m_fStandAlone);
	    System.out.println("nc_applet_count = "+nc_applet_count);
	  }
	if(in_resizable_window)
	  {
	    if(Math.abs(old_width - new_width) > 5 || 
	       Math.abs(old_height - new_height) > 5)
	      {
		if(initialized)
		  {
		    hide();
		    removeAll();
		    init();
		    show();
		  }
		old_width = new_width;
		old_height = new_height;
	      }
	  }
      }
    catch(Exception e)
      {
	e.printStackTrace();
      }
  }

  public static Dimension minSize = new Dimension(700,500);

  public Dimension minumumSize()
  {
    return minSize;
  }

  boolean inside_init = false;
  Font prefferedFont = null;
  boolean initialized = false;
  boolean first_init = true;

  // The init() method is called by the AWT when an applet is first loaded or
  // reloaded.  Override this method to perform whatever initialization your
  // applet needs, such as initializing data structures, loading images or
  // fonts, creating frame windows, setting the layout manager, or adding UI
  // components.
  //--------------------------------------------------------------------------
public void init()
  {
    try
      {
	initialized = false;
	if(inside_init)
	  {
	    System.err.println("Can't init twice at the same time.");
	    return;
	  }

	inside_init = true;

	  if(!NMLInitialized)
	  {
	    InitializeNML();
	  }

	try
	  {
	    if (!m_fStandAlone && first_init)
	      GetParameters(null);
	  }
	catch(Exception e)
	  {
	    e.printStackTrace();
	  }

	// If you use a ResourceWizard-generated "control creator" class to
	// arrange controls in your applet, you may want to call its
	// CreateControls() method from within this method. Remove the following
	// call to resize() before adding the call to CreateControls();
	// CreateControls() does its own resizing.
	//----------------------------------------------------------------------
	//resize(800, 600);

	try
	  {
	    int tries = 0;
	    while(tries < 20 && (size().height < 1 || size().width < 1))
	      {
		Thread.sleep(100);
	      }
	  }
	catch(Exception e)
	  {
	    e.printStackTrace();
	  }
	try
	  {
	    if(null == prefferedFont)
	      {
		prefferedFont = new Font("TimesRoman", Font.PLAIN, 10);
	      }
	    setFont(prefferedFont);
	  }
	catch(Exception e)
	  {
	    e.printStackTrace();
	  }

	Dimension sz = size();

	if(sz.width < minSize.width || sz.height < minSize.height)
	  {
	    int w = sz.width;
	    if(sz.width < minSize.width)
	      {
		w = minSize.width;
	      }
	    int h = sz.height;
	    if(sz.height < minSize.height)
	      {
		h = minSize.height;
	      }
	    resize(w,h);
	  }
	
	if(debug_on)
	  {
	    System.out.println("Initializing NCapplet . . . on "+new Date());
	    System.out.println("size = "+size().width+"X"+size().height);
	    Thread.dumpStack();
	  }

	int text_length = 36;
	int text_width = 80;
		
	try
	  {
	    Font f = getFont();
	    int font_height = 10;
	    int font_width = 10;
	    if(null != f)
	      {
		FontMetrics fm = getFontMetrics(f);
		if(null != fm)
		  {
		    font_height = fm.getHeight();
		    if(font_height < 10)
		      {
			font_height = 10;
		      }
		    int font_widths[] = fm.getWidths();
		    font_width = 0;
		    for(int i = 0; i < font_widths.length; i++)
		      {
			if(font_width < font_widths[i])
			  {
			    font_width = font_widths[i];
			  }
		      }
		    if(font_width < 10)
		      {
			font_width = 10;
		      }
		  }
	      }
	    if(debug_on)
	      {
		System.out.println("font_height = "+font_height);
		System.out.println("font_width = "+font_width);
	      }
	    if(size().height > 0)
	      {
		text_length = (size().height - 120)/font_height;
	      }
	    if(text_length < 30)
	      {
		text_length = 30;
	      }
	    if(size().width > 0)
	      {
		text_width = (size().width - 4)/font_width;
	      }
	    if(text_width < 40)
	      {
		text_width = 40;
	      }
	  }
	catch(Exception e)
	  {
	    e.printStackTrace();
	  }

	if(debug_on)
	  {
	    System.out.println("text_length = "+text_length);
	    System.out.println("text_width = "+text_width);
	  }

	CheckForColor();

		

	mainLayout = new FlowLayout(FlowLayout.LEFT);
	mainInnerPanel = new Panel();
	mainInnerLayout = new GridBagLayout();
	mainInnerPanel.setLayout(mainInnerLayout);
	GridBagConstraints c = new GridBagConstraints();
	titleBarLabel = new Label(". . .  NC Graphical User Interface  . . .",Label.CENTER);
	titleBarLabel.setBackground(Color.white);
	mainInnerPanel.add(titleBarLabel);
	c.gridx = 0;
	c.gridy = 0;
	if(rcs.utils.BrowserInfo.IsJava1_1_or_later())
	  {
	    c.insets = new Insets(1,1,1,1);
	  }
	c.fill = GridBagConstraints.HORIZONTAL;
	mainInnerLayout.setConstraints(titleBarLabel,c);
	newWindowButton = new Button("New Window");
	mainInnerPanel.add(newWindowButton);
	c.gridx = 1;
	c.gridy = 0;
	mainInnerLayout.setConstraints(newWindowButton,c);
	initButton = new Button("INIT");
	mainInnerPanel.add(initButton);
	c.gridx = 2;
	c.gridy = 0;
	mainInnerLayout.setConstraints(initButton,c);
	abortButton = new Button("ABORT");
	mainInnerPanel.add(abortButton);
	c.gridx = 3;
	c.gridy = 0;
	mainInnerLayout.setConstraints(abortButton,c);
		
	choiceStatusPanel = new Panel();
	choiceStatusLayout = new GridBagLayout();
	choiceStatusPanel.setLayout(choiceStatusLayout);
	if(rcs.utils.BrowserInfo.IsJava1_1_or_later())
	  {
	    choiceStatusPanel.setBackground(Color.black);
	  }
	choicePanel = new Panel();
	choiceLayout = new CardLayout();
	choicePanel.setLayout(choiceLayout);
	int positionPanelWidth = size().width -10;
	int positionPanelHeight = size().height -120;
	if(positionPanelHeight > 650)
	  {
	    positionPanelHeight = 650;
	  }
	if(positionPanelWidth > 0 && positionPanelHeight > 0)
	  {
	    positionPanel = new PositionDisplayPanel(positionPanelWidth,positionPanelHeight);
	  }
	if(debug_on)
	  {
	    System.out.println("new PositionDisplayPanel("+	String.valueOf(size().width -4)+", "+ String.valueOf(size().height -120)+")");
	  }
	choicePanel.add("position",positionPanel);
	if(debug_on)
	  {
	    System.out.println("positionPanel.size() = "+ positionPanel.size().toString());
	  }
	programPanel = new Panel();	
	programLayout = new FlowLayout(FlowLayout.LEFT);
	programPanel.setLayout(programLayout);
	programPanel.setBackground(Color.lightGray);
	programInnerPanel = new Panel();	
	programInnerLayout = new GridBagLayout();
	programInnerPanel.setLayout(programInnerLayout);
	programInnerPanel.setBackground(Color.lightGray);
	int text_field_width = text_width/2 - 5;
	String spacer = "_";
	for(int i = 0; i < text_field_width; i++)
	  {
	    spacer += "_";
	  }
	if(null != programTextField)
	  {
	    String oldFieldValue  = programTextField.getText();
	    programTextField = new TextField(oldFieldValue, text_field_width);
	  }
	else
	  {
	    programTextField = new TextField(spacer,text_field_width);
	  }
	programInnerPanel.add(programTextField);
	c.gridx = 0;
	c.gridy = 0;
	c.fill = GridBagConstraints.HORIZONTAL;
	programInnerLayout.setConstraints(programTextField,c);
	int prog_list_length = ((text_length -25)*9)/10;
	if(prog_list_length < 10)
	  {
	    prog_list_length = 10;
	  }
	programList = new java.awt.List(prog_list_length,true);
	for(int i = 0; i < prog_list_length+3; i++)
	  {
	    programList.addItem("PROGRAM_LINE ("+i+")"+spacer);
	  }
	programInnerPanel.add(programList);
	c.gridx = 0;
	c.gridy = 1;
	c.fill = GridBagConstraints.HORIZONTAL;
	c.gridheight = 20;
	programInnerLayout.setConstraints(programList,c);
	loadProgramButton = new Button("load");
	programInnerPanel.add(loadProgramButton);
	c.gridx = 1;
	c.gridy = 0;
	c.gridheight = 1;
	programInnerLayout.setConstraints(loadProgramButton,c);
	browseLocalButton = new Button("browseLocal");
	programInnerPanel.add(browseLocalButton);
	c.gridx = 1;
	c.gridy = 1;
	programInnerLayout.setConstraints(browseLocalButton,c);
	browseRemoteButton = new Button("browseRemote");
	programInnerPanel.add(browseRemoteButton);
	c.gridx = 1;
	c.gridy = 2;
	programInnerLayout.setConstraints(browseRemoteButton,c);
	runButton = new Button("run");
	programInnerPanel.add(runButton);
	c.gridx = 1;
	c.gridy = 3;
	programInnerLayout.setConstraints(runButton,c);
	haltButton = new Button("halt");
	programInnerPanel.add(haltButton);
	c.gridx = 1;
	c.gridy = 4;
	programInnerLayout.setConstraints(haltButton,c);
	holdButton = new Button("hold");
	programInnerPanel.add(holdButton);
	c.gridx = 1;
	c.gridy = 5;
	programInnerLayout.setConstraints(holdButton,c);
	resumeButton = new Button("resume");
	programInnerPanel.add(resumeButton);
	c.gridx = 1;
	c.gridy = 6;
	programInnerLayout.setConstraints(resumeButton,c);
	singleStepButton = new Button("singleStep");
	programInnerPanel.add(singleStepButton);
	c.gridx = 1;
	c.gridy = 7;
	programInnerLayout.setConstraints(singleStepButton,c);
	c.gridwidth = 2;
	XProgPosLabel = new Label("X: 0.00E00 mm.");
	programInnerPanel.add(XProgPosLabel);
	c.gridx = 2;
	c.gridy = 0;
	programInnerLayout.setConstraints(XProgPosLabel,c);
	YProgPosLabel = new Label("Y: 0.00E00 mm.");
	programInnerPanel.add(YProgPosLabel);
	c.gridx = 2;
	c.gridy = 1;
	programInnerLayout.setConstraints(YProgPosLabel,c);
	ZProgPosLabel = new Label("Z: 0.00E00 mm.");
	programInnerPanel.add(ZProgPosLabel);
	c.gridx = 2;
	c.gridy = 2;
	programInnerLayout.setConstraints(ZProgPosLabel,c);

	XProgOffsetLabel = new Label("X Offset: 0.00E00 mm.");
	programInnerPanel.add(XProgOffsetLabel);
	c.gridx = 4;
	c.gridy = 0;
	programInnerLayout.setConstraints(XProgOffsetLabel,c);
	YProgOffsetLabel = new Label("Y Offset: 0.00E00 mm.");
	programInnerPanel.add(YProgOffsetLabel);
	c.gridx = 4;
	c.gridy = 1;
	programInnerLayout.setConstraints(YProgOffsetLabel,c);
	ZProgOffsetLabel = new Label("Z Offset: 0.00E00 mm.");
	programInnerPanel.add(ZProgOffsetLabel);
	c.gridx = 4;
	c.gridy = 2;
	programInnerLayout.setConstraints(ZProgOffsetLabel,c);

	int mdiOldCommandsAreaWidth = text_width*2/3 -10;
	int mdiOldCommandsAreaLength = text_length/4 -5;
	if(mdiOldCommandsAreaLength > 7)
	  {
	    mdiOldCommandsAreaLength = 7;
	  }
	c.gridy = 3;
	mdiLabel = null;
	mdiOldCommandsArea = null;
	if(mdiOldCommandsAreaWidth > 30 && mdiOldCommandsAreaLength > 2)
	  {
	    mdiLabel = new Label("Manual Data Input(MDI)");
	    programInnerPanel.add(mdiLabel);
	    c.gridx = 2;
	    c.gridwidth = 2;
	    programInnerLayout.setConstraints(mdiLabel,c);
	    c.gridy = 4;
	    mdiOldCommandsArea = new TextArea(mdiOldCommandsAreaLength,mdiOldCommandsAreaWidth);
	    programInnerPanel.add(mdiOldCommandsArea);
	    c.gridx = 2;
	    c.gridwidth = 2;
	    c.gridheight = mdiOldCommandsAreaLength;
	    programInnerLayout.setConstraints(mdiOldCommandsArea,c);
	    c.gridy += mdiOldCommandsAreaLength;
	  }
	if(mdiOldCommandsAreaWidth > 30 )
	  {
	    mdiExecField = new TextField("Enter MDI commands here!");
	  }
	else
	  {
	    mdiExecField = new TextField("MDI here");
	  }
	programInnerPanel.add(mdiExecField);
	c.gridx = 2;
	c.gridwidth = 1;
	c.gridheight = 1;
	programInnerLayout.setConstraints(mdiExecField,c);
	if(mdiOldCommandsAreaWidth > 30)
	  {
	    mdiExecButton = new Button("Execute");
	    programInnerPanel.add(mdiExecButton);
	    c.gridx = 3;
	    c.gridwidth = 1;
	    c.gridheight = 1;
	    programInnerLayout.setConstraints(mdiExecButton,c);
	  }

	c.gridwidth = 2;
	GCodesLabel1 = new Label("G-Codes: G000,G000,G000,G000,G000,G000," );
	programInnerPanel.add(GCodesLabel1);
	c.gridx = 0;
	c.gridy = 21;
	programInnerLayout.setConstraints(GCodesLabel1,c);
	GCodesLabel2 = new Label("G-Codes: G000,G000,G000,G000,G000,G000," );
	programInnerPanel.add(GCodesLabel2);
	c.gridx = 0;
	c.gridy = 22;
	programInnerLayout.setConstraints(GCodesLabel2,c);
	MCodesLabel1 = new Label("M-Codes: M000,M000,M000,M000,M000,M000,");
	programInnerPanel.add(MCodesLabel1);
	c.gridx = 0;
	c.gridy = 23;
	programInnerLayout.setConstraints(MCodesLabel1,c);
	MCodesLabel2 = new Label("M-Codes: M000,M000,M000,M000,M000,M000,");
	programInnerPanel.add(MCodesLabel2);
	c.gridx = 0;
	c.gridy = 24;
	programInnerLayout.setConstraints(MCodesLabel2,c);
	c.gridheight = 1;
	c.gridwidth = 1;
	programPanel.add(programInnerPanel);
	choicePanel.add("program",programPanel);
	if(debug_on)
	  {
	    System.out.println("programPanel.size() = "+ programPanel.size().toString());
	  }

	toolTablePanel = new Panel();
	toolTableLayout = new FlowLayout(FlowLayout.LEFT);
	toolTablePanel.setLayout(toolTableLayout);
	toolTableInnerPanel = new Panel();
	toolTableInnerLayout = new GridBagLayout();
	toolTableInnerPanel.setLayout(toolTableInnerLayout);
	toolTableTextField = new TextField("", text_width-7);
	toolTableInnerPanel.add(toolTableTextField);
	c.gridx = 0;
	c.gridy = 0;
	toolTableInnerLayout.setConstraints(toolTableTextField,c);
	toolTableLoadButton = new Button("LOAD");
	toolTableInnerPanel.add(toolTableLoadButton);
	c.gridx = 1;
	c.gridy = 0;
	toolTableInnerLayout.setConstraints(toolTableLoadButton,c);
	int tool_list_length = ((text_length -25)*9)/10;
	if(tool_list_length < 12)
	  {
	    tool_list_length = 12;
	  }
	toolTableList = new java.awt.List(tool_list_length,false);
	for(int i = 0; i < tool_list_length+3; i++)
	  {
	    toolTableList.addItem("TOOL ("+i+")"+spacer);
	  }
	toolTableInnerPanel.add(toolTableList);
	c.gridx = 0;
	c.gridy = 1;
	c.gridwidth = 2;
	toolTableInnerLayout.setConstraints(toolTableList,c);
	toolTableInnerPanel.setBackground(Color.lightGray);
	toolTablePanel.add(toolTableInnerPanel);
	toolTablePanel.setBackground(Color.lightGray);
	choicePanel.add("tooltable",toolTablePanel);
	errlogPanel = new Panel();
	errlogLayout = new FlowLayout(FlowLayout.LEFT);
	errlogPanel.setLayout(errlogLayout);
	errlogPanel.setBackground(Color.lightGray);
	errlogInnerPanel = new Panel();
	errlogInnerLayout = new GridBagLayout();
	errlogInnerPanel.setLayout(errlogInnerLayout);
	errlogInnerPanel.setBackground(Color.lightGray);
	readErrlogCheckbox = new Checkbox("Read ErrorLog",null, true);
	errlogInnerPanel.add(readErrlogCheckbox);
	c.gridx = 0;
	c.gridy = 0;
	c.gridwidth = 1;
	errlogInnerLayout.setConstraints(readErrlogCheckbox,c);
	clearErrlogButton = new Button("Clear");
	errlogInnerPanel.add(clearErrlogButton);
	c.gridx = 1;
	c.gridy = 0;
	c.gridwidth = 1;
	errlogInnerLayout.setConstraints(clearErrlogButton,c);
	int errlog_length = (text_length -25);
	if(errlog_length < 12)
	  {
	    errlog_length = 12;
	  }
	errlogTextArea = new TextArea(errlog_length,(text_width-10));
	errlogInnerPanel.add(errlogTextArea);
	c.gridx = 0;
	c.gridy = 1;
	c.gridwidth = 3;
	errlogInnerLayout.setConstraints(errlogTextArea,c);
	errlogPanel.add(errlogInnerPanel);
	c.gridwidth = 1;
		
	choicePanel.add("errlog",errlogPanel);
	if(debug_on)
	  {
	    System.out.println("errlogPanel.size() = "+ errlogPanel.size().toString());
	  }
	cpanelPanel = new Panel();
	cpanelLayout = new FlowLayout(FlowLayout.LEFT);
	cpanelPanel.setLayout(cpanelLayout);
	cpanelPanel.setBackground(Color.lightGray);
	cpanelInnerPanel = new Panel();
	cpanelInnerLayout = new GridBagLayout();
	cpanelInnerPanel.setLayout(cpanelInnerLayout);
	cpanelInnerPanel.setBackground(Color.lightGray);
	estopButton = new Button("ESTOP");
	if(m_UseColor)
	  {
	    estopButton.setBackground(Color.red);
	  }
	cpanelInnerPanel.add(estopButton);
	c.gridx =  0;
	c.gridy =  0;
	cpanelInnerLayout.setConstraints(estopButton, c);
	estopResetButton = new Button("E-STOP Reset");
	cpanelInnerPanel.add(estopResetButton);
	c.gridx =  0;
	c.gridy =  1;
	cpanelInnerLayout.setConstraints(estopResetButton, c);
	machineOnButton = new Button("Machine On");
	cpanelInnerPanel.add(machineOnButton);
	c.gridx =  0;
	c.gridy =  2;
	cpanelInnerLayout.setConstraints(machineOnButton, c);
	machineOffButton = new Button("Machine Off");
	cpanelInnerPanel.add(machineOffButton);
	c.gridx =  0;
	c.gridy =  3;
	cpanelInnerLayout.setConstraints(machineOffButton, c);
	modeLabel = new Label("Mode",Label.CENTER);
	cpanelInnerPanel.add(modeLabel);
	c.gridx =  1;
	c.gridy =  0;
	cpanelInnerLayout.setConstraints(modeLabel, c);
	manualButton = new Button("Manual");
	cpanelInnerPanel.add(manualButton);
	c.gridx =  1;
	c.gridy =  1;
	cpanelInnerLayout.setConstraints(manualButton, c);
	autoButton = new Button("Auto");
	cpanelInnerPanel.add(autoButton);
	c.gridx =  1;
	c.gridy =  2;
	cpanelInnerLayout.setConstraints(autoButton, c);
	mdiButton = new Button("MDI");
	cpanelInnerPanel.add(mdiButton);
	c.gridx =  1;
	c.gridy =  3;
	cpanelInnerLayout.setConstraints(mdiButton, c);
	autoSetModeCheckbox = new Checkbox("Set mode before sending commands", null,true);
	cpanelInnerPanel.add(autoSetModeCheckbox);
	c.gridx = 0;
	c.gridy = 4;
	c.gridwidth = 3;
	cpanelInnerLayout.setConstraints(autoSetModeCheckbox, c);
	c.gridwidth = 1;
		
		

	jogTypeLabel = new Label("Jog Type:");
	cpanelInnerPanel.add(jogTypeLabel);
	c.gridx = 2;
	c.gridy = 0;
	cpanelInnerLayout.setConstraints(jogTypeLabel, c);
	jogTypeChoice = new Choice();
	jogTypeChoice.addItem("Continuous");
	jogTypeChoice.addItem("0.1 mm Increment");
	jogTypeChoice.addItem("1 mm Increment");
	jogTypeChoice.addItem("10 mm Increment");
	jogTypeChoice.addItem("0.0001 inch Increment");
	jogTypeChoice.addItem("0.001 inch Increment");
	jogTypeChoice.addItem("0.01 inch Increment");
	jogTypeChoice.addItem("0.1 inch Increment");
	jogTypeChoice.addItem("1 inch Increment");
	jogTypeChoice.select("Continuous");
	cpanelInnerPanel.add(jogTypeChoice);
	c.gridx = 2;
	c.gridy = 1;
	cpanelInnerLayout.setConstraints(jogTypeChoice, c);
		
	jogSpeedLabel = new Label("Jog Speed: "+jog_speed+" mm/s");
	cpanelInnerPanel.add(jogSpeedLabel);
	c.gridx = 2;
	c.gridy = 2;
	cpanelInnerLayout.setConstraints(jogSpeedLabel, c);
		
	jogSpeedSlider = new Scrollbar(Scrollbar.HORIZONTAL);
	jogSpeedSlider.setValues(jog_speed,1,0,50);
	cpanelInnerPanel.add(jogSpeedSlider);
	c.gridx = 2;
	c.gridy = 3;
	cpanelInnerLayout.setConstraints(jogSpeedSlider, c);
	jog_speed = jogSpeedSlider.getValue();
	jogSpeedSlider.setValue(jog_speed);
	jogSpeedLabel.setText("Jog Speed: "+FormatDouble(((double)jog_speed),7)+" mm/s");
		
	axisControlLabel = new Label("Axis Control",Label.CENTER);
	cpanelInnerPanel.add(axisControlLabel);
	c.gridy = 0;
	c.gridx = 3;
	c.gridwidth = 4;
	cpanelInnerLayout.setConstraints( axisControlLabel, c);
	c.gridwidth = 1;

	c.gridy = 1;
	XPositionLabel = new Label("X: 0.00000 mm");
	cpanelInnerPanel.add(XPositionLabel);
	cpanelInnerLayout.setConstraints( XPositionLabel, c);
	c.gridx++;
	XJogPlusButton = new JogButton("Jog +");
	cpanelInnerPanel.add(XJogPlusButton);
	cpanelInnerLayout.setConstraints( XJogPlusButton, c);
	c.gridx++;
	XJogMinusButton = new JogButton("Jog -");
	cpanelInnerPanel.add(XJogMinusButton);
	cpanelInnerLayout.setConstraints( XJogMinusButton, c);
	c.gridx++;
	XHomeButton = new Button("Home");
	cpanelInnerPanel.add(XHomeButton);
	cpanelInnerLayout.setConstraints( XHomeButton, c);
	c.gridx++;
	XEnableCheckbox = new Checkbox("Enabled");
	cpanelInnerPanel.add(XEnableCheckbox);
	cpanelInnerLayout.setConstraints( XEnableCheckbox, c);
	c.gridx++;
	XLocalOffsetCheckbox = new Checkbox("Offset:"+x_local_offset);
	cpanelInnerPanel.add(XLocalOffsetCheckbox);
	cpanelInnerLayout.setConstraints( XLocalOffsetCheckbox, c);
	c.gridy++;
	c.gridx = 3;

		
	YPositionLabel = new Label("Y: 0.00000 mm");
	cpanelInnerPanel.add(YPositionLabel);
	cpanelInnerLayout.setConstraints( YPositionLabel, c);
	c.gridx++;
	YJogPlusButton = new JogButton("Jog +");
	cpanelInnerPanel.add(YJogPlusButton);
	cpanelInnerLayout.setConstraints( YJogPlusButton, c);
	c.gridx++;
	YJogMinusButton = new JogButton("Jog -");
	cpanelInnerPanel.add(YJogMinusButton);
	cpanelInnerLayout.setConstraints( YJogMinusButton, c);
	c.gridx++;
	YHomeButton = new Button("Home");
	cpanelInnerPanel.add(YHomeButton);
	cpanelInnerLayout.setConstraints( YHomeButton, c);
	c.gridx++;
	YEnableCheckbox = new Checkbox("Enabled");
	cpanelInnerPanel.add(YEnableCheckbox);
	cpanelInnerLayout.setConstraints( YEnableCheckbox, c);
	c.gridx++;
	YLocalOffsetCheckbox = new Checkbox("Offset:"+y_local_offset);
	cpanelInnerPanel.add(YLocalOffsetCheckbox);
	cpanelInnerLayout.setConstraints( YLocalOffsetCheckbox, c);
	c.gridy++;
	c.gridx = 3;


	ZPositionLabel = new Label("Z: 0.00000 mm");
	cpanelInnerPanel.add(ZPositionLabel);
	cpanelInnerLayout.setConstraints( ZPositionLabel, c);
	c.gridx++;
	ZJogPlusButton = new JogButton("Jog +");
	cpanelInnerPanel.add(ZJogPlusButton);
	cpanelInnerLayout.setConstraints( ZJogPlusButton, c);
	c.gridx++;
	ZJogMinusButton = new JogButton("Jog -");
	cpanelInnerPanel.add(ZJogMinusButton);
	cpanelInnerLayout.setConstraints( ZJogMinusButton, c);
	c.gridx++;
	ZHomeButton = new Button("Home");
	cpanelInnerPanel.add(ZHomeButton);
	cpanelInnerLayout.setConstraints( ZHomeButton, c);
	c.gridx++;
	ZEnableCheckbox = new Checkbox("Enabled");
	cpanelInnerPanel.add(ZEnableCheckbox);
	cpanelInnerLayout.setConstraints( ZEnableCheckbox, c);
	c.gridx++;
	ZLocalOffsetCheckbox = new Checkbox("Offset:"+z_local_offset);
	cpanelInnerPanel.add(ZLocalOffsetCheckbox);
	cpanelInnerLayout.setConstraints( ZLocalOffsetCheckbox, c);
	c.gridx = 0;
		
	// Feedrate controls
	c.gridy= 5;
	feedrateOverrideLabel = new Label("Feedrate Override: 100.0%");
	cpanelInnerPanel.add(feedrateOverrideLabel);
	c.gridwidth = 3;
	c.gridy++;
	cpanelInnerLayout.setConstraints( feedrateOverrideLabel, c);
	feedrateOverrideSlider = new Scrollbar(Scrollbar.HORIZONTAL,100,1,0,120);
	cpanelInnerPanel.add(feedrateOverrideSlider);
	c.gridy++;
	cpanelInnerLayout.setConstraints( feedrateOverrideSlider, c);
		
	// Spindle controls
	spindleOverrideLabel = new Label("Spindle Override: 100.0%");
	cpanelInnerPanel.add(spindleOverrideLabel);
	c.gridwidth = 3;
	c.gridy++;
	cpanelInnerLayout.setConstraints( spindleOverrideLabel, c);
	spindleOverrideSlider = new Scrollbar(Scrollbar.HORIZONTAL,100,1,0,120);
	cpanelInnerPanel.add(spindleOverrideSlider);
	c.gridy++;
	cpanelInnerLayout.setConstraints( spindleOverrideSlider, c);
		
	c.gridy++;
	c.gridx = 0;
	c.gridwidth = 1;
	spindleCCWButton = new Button("Spindle CCW");
	cpanelInnerPanel.add(spindleCCWButton);
	cpanelInnerLayout.setConstraints( spindleCCWButton, c);

	c.gridx = 1;
	spindleOffButton = new Button("Spindle Off");
	cpanelInnerPanel.add(spindleOffButton);
	cpanelInnerLayout.setConstraints( spindleOffButton, c);

	c.gridx = 2;
	spindleCWButton = new Button("Spindle CW");
	cpanelInnerPanel.add(spindleCWButton);
	cpanelInnerLayout.setConstraints( spindleCWButton, c);


	c.gridy++;
	c.gridx = 0;
	spindleIncrButton = new JogButton("Spindle Increase",120,20);
	cpanelInnerPanel.add(spindleIncrButton);
	cpanelInnerLayout.setConstraints( spindleIncrButton, c);
	
	c.gridx = 1;
	spindleDecrButton = new JogButton("Spindle Decrease",120,20);
	cpanelInnerPanel.add(spindleDecrButton);
	cpanelInnerLayout.setConstraints( spindleDecrButton, c);

	c.gridy++;
	c.gridx = 0;
	spindleBrakeCheckbox = new Checkbox("Spindle Brake");
	cpanelInnerPanel.add(spindleBrakeCheckbox);
	cpanelInnerLayout.setConstraints( spindleBrakeCheckbox, c);

	
	c.gridy++;
	c.gridx = 0;
	connectedCheckbox = new Checkbox("Connected",null, is_connected);
	cpanelInnerPanel.add(connectedCheckbox);
	cpanelInnerLayout.setConstraints( connectedCheckbox, c);

	c.gridx = 1;
	NMLfileLabel = new Label("NML Configuration File:");
	cpanelInnerPanel.add(NMLfileLabel);
	cpanelInnerLayout.setConstraints( NMLfileLabel, c);

	c.gridx = 2;
	NMLfileTextField = new TextField(m_NMLfile,20);
	cpanelInnerPanel.add(NMLfileTextField);
	cpanelInnerLayout.setConstraints( NMLfileTextField, c);

	c.gridy++;
	c.gridx = 0;
	relativePositionCheckbox = new Checkbox("RelativePosition");
	cpanelInnerPanel.add(relativePositionCheckbox);
	cpanelInnerLayout.setConstraints( relativePositionCheckbox, c);

	unitsGroup = new CheckboxGroup();
	c.gridy++;
	c.gridx = 0;
	inchesCheckbox = new Checkbox("Inches",unitsGroup, false);
	cpanelInnerPanel.add(inchesCheckbox);
	cpanelInnerLayout.setConstraints( inchesCheckbox, c);

	c.gridy++;
	c.gridx = 0;
	mmCheckbox = new Checkbox("Millimeters",unitsGroup, true);
	cpanelInnerPanel.add(mmCheckbox);
	cpanelInnerLayout.setConstraints( mmCheckbox, c);


	c.gridy++;
	c.gridx = 0;
	memCleanCheckButton  = new Button("Memory Check/Cleanup");
	cpanelInnerPanel.add(memCleanCheckButton);
	cpanelInnerLayout.setConstraints( memCleanCheckButton, c);


	c.gridy++;
	c.gridx = 0;
	cycleTimeLabel  = new Label("Cycle Time: "+cycle_time+" secs. (100.0%");	
	cpanelInnerPanel.add(cycleTimeLabel);
	cpanelInnerLayout.setConstraints( cycleTimeLabel, c);

	
	c.gridy++;
	c.gridx = 0;
	cycleTimeScrollbar  = new Scrollbar(Scrollbar.HORIZONTAL,(int) (cycle_time*1000), 20, 20, 5000);
	cpanelInnerPanel.add(cycleTimeScrollbar);
	cpanelInnerLayout.setConstraints( cycleTimeScrollbar, c);



	c.gridx = 4;
	c.gridy = 5;
	c.gridwidth = 3;
	c.gridy++;
	userNameLabel = new Label("User Name");
	cpanelInnerPanel.add(userNameLabel);
	cpanelInnerLayout.setConstraints( userNameLabel, c);
	c.gridy++;
	userNameField = new TextField();
	cpanelInnerPanel.add(userNameField);
	cpanelInnerLayout.setConstraints( userNameField, c);
	c.gridy++;
	userPasswdLabel = new Label("User Passwd");
	cpanelInnerPanel.add(userPasswdLabel);
	cpanelInnerLayout.setConstraints( userPasswdLabel, c);
	c.gridy++;
	userPasswdField = new TextField();
	userPasswdField.setEchoCharacter('*');
	cpanelInnerPanel.add(userPasswdField);
	cpanelInnerLayout.setConstraints( userPasswdField, c);
	if(m_UserName != null)
	  {
	    userNameField.setText(m_UserName);
	  }
	if(m_UserPasswd != null)
	  {
	    userPasswdField.setText(m_UserPasswd);
	  }


	c.gridy = 5;
	c.gridx = 8;
	c.gridwidth = 1;
	HeartBeatLabel = new Label("Heartbeats");
	cpanelInnerPanel.add(HeartBeatLabel);
	cpanelInnerLayout.setConstraints( HeartBeatLabel, c);

	c.gridy++;
	GuiHeartBeatLabel = new Label("GUI: 0");
	cpanelInnerPanel.add(GuiHeartBeatLabel);
	cpanelInnerLayout.setConstraints( GuiHeartBeatLabel, c);

	c.gridy++;
	TaskHeartBeatLabel = new Label("TASK: 0");
	cpanelInnerPanel.add(TaskHeartBeatLabel);
	cpanelInnerLayout.setConstraints( TaskHeartBeatLabel, c);

	c.gridy++;
	IoHeartBeatLabel = new Label("IO: 0");
	cpanelInnerPanel.add(IoHeartBeatLabel);
	cpanelInnerLayout.setConstraints( IoHeartBeatLabel, c);

	c.gridy++;
	MotionHeartBeatLabel = new Label("MOTION: 0");
	cpanelInnerPanel.add(MotionHeartBeatLabel);
	cpanelInnerLayout.setConstraints( MotionHeartBeatLabel, c);

	



	cpanelPanel.add(cpanelInnerPanel);
	choicePanel.add("cpanel",cpanelPanel);
	if(debug_on)
	  {
	    System.out.println("cpanelPanel.size() = "+ cpanelPanel.size().toString());
	  }
	choiceLayout.show(choicePanel, choice_layout_selection);
	choicePanel.setBackground(Color.lightGray);
	choiceStatusPanel.add(choicePanel);
	c.fill = GridBagConstraints.HORIZONTAL;
	c.gridx = 0;
	c.gridy = 0;
	choiceStatusLayout.setConstraints(choicePanel,c);
	statusPanel = new Panel();
	if(rcs.utils.BrowserInfo.IsJava1_1_or_later())
	  {
	    statusLayout = new GridLayout(2,6,1,1);
	  }
	else
	  {
	    statusLayout = new GridLayout(2,6);
	  }
	statusPanel.setLayout(statusLayout);
	estopStatusLabel = new Label("ESTOP", Label.CENTER);
	if(m_UseColor)
	  {
	    estopStatusLabel.setBackground(Color.red);
	  }
	else
	  {
	    estopStatusLabel.setBackground(Color.lightGray);
	  }
	statusPanel.add(estopStatusLabel);
	powerStatusLabel = new Label("Power Off", Label.CENTER);
	powerStatusLabel.setBackground(Color.lightGray);
	statusPanel.add(powerStatusLabel);
	execStatusLabel = new Label("Exec Done", Label.CENTER);
	execStatusLabel.setBackground(Color.lightGray);
	statusPanel.add(execStatusLabel);
	programStatusLabel = new Label("Prog Stopped", Label.CENTER);
	programStatusLabel.setBackground(Color.lightGray);
	statusPanel.add(programStatusLabel);
	inposStatusLabel = new Label("In Position", Label.CENTER);
	inposStatusLabel.setBackground(Color.white);
	statusPanel.add(inposStatusLabel);
	modeStatusLabel = new Label("Manual Mode", Label.CENTER);
	if(m_UseColor)
	  {
	    modeStatusLabel.setBackground(Color.cyan);
	  }
	else
	  {
	    modeStatusLabel.setBackground(Color.lightGray);
	  }
	statusPanel.add(modeStatusLabel);
	feedrateStatusLabel = new Label("Feed 0.00", Label.CENTER);
	feedrateStatusLabel.setBackground(Color.white);
	statusPanel.add(feedrateStatusLabel);
	spindleStatusLabel = new Label("Speed 0.00", Label.CENTER);
	spindleStatusLabel.setBackground(Color.white);
	statusPanel.add(spindleStatusLabel);
	errlogStatusLabel = new Label("0 Errors", Label.CENTER);
	errlogStatusLabel.setBackground(Color.lightGray);
	statusPanel.add(errlogStatusLabel);
	homingStatusLabel = new Label("0 Homing", Label.CENTER);
	homingStatusLabel.setBackground(Color.lightGray);
	statusPanel.add(homingStatusLabel);
	homedStatusLabel = new Label("0 Homed", Label.CENTER);
	if(m_UseColor)
	  {
	    homedStatusLabel.setBackground(Color.red);
	  }
	else
	  {
	    homedStatusLabel.setBackground(Color.lightGray);
	  }
	statusPanel.add(homedStatusLabel);
	loginStatusLabel = new Label("No Login", Label.CENTER);	
	loginStatusLabel.setBackground(Color.lightGray);
	statusPanel.add(loginStatusLabel);
	if(rcs.utils.BrowserInfo.IsJava1_1_or_later())
	  {
	    statusPanel.setBackground(Color.black);
	  }
	choiceStatusPanel.add(statusPanel);
	c.gridx = 0;
	c.gridy = 1;
	choiceStatusLayout.setConstraints(statusPanel,c);

	mainInnerPanel.add(choiceStatusPanel);
	c.gridx = 0;
	c.gridy = 1;
	c.gridwidth = 4;
	mainInnerLayout.setConstraints(choiceStatusPanel,c);
	c.gridwidth = 1;
		
	buttonPanel = new Panel();
	if(rcs.utils.BrowserInfo.IsJava1_1_or_later())
	  {
	    buttonPanelLayout = new GridLayout(1,5,2,2);
	  }
	else
	  {
	    buttonPanelLayout = new GridLayout(1,5);
	  }
	buttonPanel.setLayout(buttonPanelLayout);
	buttonPanel.setBackground(Color.lightGray);
	positionButton = new Button("Position");
	positionButton.setBackground(Color.lightGray);
	buttonPanel.add(positionButton);
	programButton = new Button("Program");
	programButton.setBackground(Color.lightGray);
	buttonPanel.add(programButton);
	toolTableButton = new Button("Tool Table");
	toolTableButton.setBackground(Color.lightGray);
	buttonPanel.add(toolTableButton);
	cpanelButton = new Button("Control Panel");
	cpanelButton.setBackground(Color.lightGray);
	buttonPanel.add(cpanelButton);
	errlogButton = new Button("Error Log");
	errlogButton.setBackground(Color.lightGray);
	buttonPanel.add(errlogButton);
	mainInnerPanel.add(buttonPanel);
	c.gridx = 0;
	c.gridy = 2;
	c.gridwidth = 4;
	mainInnerLayout.setConstraints(buttonPanel,c);
	c.gridwidth = 1;

	add(mainInnerPanel);
	first_stat_display = true;
	old_width = size().width;
	old_height = size().height;
	show();
      }
    catch(Exception e)
      {
	e.printStackTrace();
	}
    inside_init = false;
    initialized = true;
    first_init = false;
	
  }

  // Place additional applet clean up code here.  destroy() is called when
  // when you applet is terminating and being unloaded.
  //-------------------------------------------------------------------------
public void destroy()
  {
  }

  //		The start() method is called when the page containing the applet
  // first appears on the screen. The AppletWizard's initial implementation
  // of this method starts execution of the applet's thread.
  //--------------------------------------------------------------------------
public void start()
  {
    if (m_NCapplet == null)
      {
	m_NCapplet = new Thread(this);
	m_NCapplet.start();
      }
  }

  Frame parentFrame = null;
	
protected void Alert(String str)
  {
    try
      {
	if(debug_on)
	  {
	    System.out.println(str);
	  }
	if(jog_started)
	  {
	    return;
	  }
	String errorString = "GUI Error( "+str+" )"+newline;
	if(null != errlogTextArea)
	  {
	    errlogTextArea.appendText(errorString);
	  }
	if(null != mdiOldCommandsArea)
	  {
	    if(choice_layout_selection.equals("program"))
	      {
		mdiOldCommandsArea.appendText(errorString);
	      }
	  }
	num_errors++;
	num_new_errors++;
	if(null != errlogStatusLabel)
	  {
	    if(m_UseColor)
	      {
		errlogStatusLabel.setBackground(Color.red);
	      }
	    errlogStatusLabel.setText(num_errors+" errors ("+num_new_errors+" new)");
	  }
	/* if(null == parentFrame)
	   {
	   try
	   {
	   parentFrame = (Frame) getParent();
	   }
	   catch(ClassCastException e)
	   {
	   parentFrame = new Frame();
	   }
	   }
	   AlertDialog ad = new AlertDialog(parentFrame,"NC Error",str); 
	   */
      }
    catch(Exception e)
      {
	e.printStackTrace();
      }
  }

protected QueryDialog Query(String str)
  {
    try
      {
	if(jog_started)
	  {
	    return null;
	  }
	if(debug_on)
	  {
	    System.out.println(str);
	  }
	if(null == parentFrame)
	  {
	    try
	      {
		parentFrame = (Frame) getParent();
	      }
	    catch(ClassCastException e)
	      {
		parentFrame = new Frame();
	      }
	  }
	QueryDialog qd = new QueryDialog(parentFrame,"NC Query",str);
			
	return qd;
      }
    catch(Exception e)
      {
	e.printStackTrace();
      }
    return null;
  }

  boolean NMLInitialized = false;
  nml_emc nml_emc_object = null;
  
  long last_reconnect_try_time = System.currentTimeMillis();
  
  // Initialize the NML channels
  protected void InitializeNML()
  {
    //NMLFormatConverterBase.debug_on = true;
    boolean success = true;
    NMLInitialized = false;
    try
      {
	if(!m_fStandAlone)
	  {
	    if(debug_on)
	      {
		System.out.println("Setting  current_directory to "+ URL_and_FileLoader.current_directory);
	      }
	    URL codeBase = getCodeBase();
	    if(null != codeBase)
	      {
		URL_and_FileLoader.current_directory = getCodeBase().toString();
	      }
	  }
      }
    catch(Exception e)
      {
	e.printStackTrace();
      }
    try
      {
	if(debug_on)
	  {
	    System.out.println("Create nml_emc_object.");
	  }
	nml_emc_object = new nml_emc();
	if(debug_on)
	  {
	    System.out.println("Open channel to emcCommand.");
	  }
	NCCommandChannel = new NMLConnection(nml_emc_object, "emcCommand","emcJavaGui", m_NMLfile);
      }
    catch(Exception e)
      {
	success = false;
	if(!reconnect_needed)
	  {
	    Alert("Can't open NC command channel. \n"+e.getMessage());
	}
	NCCommandChannel = null;
	if(!reconnect_needed || debug_on)
	  {
	    e.printStackTrace();
	  }
      }
    try
      {
	if(debug_on)
	  {
	    System.out.println("Open channel to emcStatus.");
	  }
	NCStatusChannel = new NMLConnection(nml_emc_object, "emcStatus","emcJavaGui", m_NMLfile);
      }
    catch(Exception e)
      {
	success = false;
	if(!reconnect_needed)
	  {
	    Alert("Can't open NC status channel. \n"+e.getMessage());
	}
	NCStatusChannel = null;
	if(!reconnect_needed || debug_on)
	  {
	    e.printStackTrace();
	  }
      }
    try
      {
	if(debug_on)
	  {
	    System.out.println("Open channel to emcError.");
	  }
	NCErrlogChannel = new NMLConnection(nml_emc_object, "emcError","emcJavaGui", m_NMLfile);
      }
    catch(Exception e)
      {
	success = false;
	if(!reconnect_needed)
	{
	    Alert("Can't open NC errlog channel. \n"+e.getMessage());
	}
	NCErrlogChannel = null;
	if(!reconnect_needed || debug_on)
	  {
	    e.printStackTrace();
	  }
      }
    NMLInitialized = true;
    if(success)
      {
	is_connected = true;
	if(null != connectedCheckbox)
	  {
	    connectedCheckbox.setState(true);
	  }
      }
    NMLConnection.ClearStaticData();
    first_stat_display = true;
  }

protected void DisconnectNML()
  {
    try
      {
	if(null != NCStatusChannel)
	  {
	    NCStatusChannel.disconnect();
	    NCStatusChannel = null;
	    ncStatus = null;
	  }
	if(null != NCCommandChannel)
	  {
	    NCCommandChannel.disconnect();
	    NCCommandChannel = null;
	  }
	if(null != NCErrlogChannel)
	  {
	    NCErrlogChannel.disconnect();
	    NCErrlogChannel = null;
	  }
	is_connected = false;
	connectedCheckbox.setState(false);
      }
    catch(Exception e)
      {
	e.printStackTrace();
      }
  }

  long last_connect_try_time = 0;
  boolean reconnect_needed = false;

  protected void ReconnectNML()
  {
    try
      {
	if(null == NCStatusChannel || null == NCCommandChannel ||
	   null == NCErrlogChannel)
	  {
	    InitializeNML();
	  }
	if(null != NCStatusChannel)
	  {
	    NCStatusChannel.disconnect();
	    NCStatusChannel.connect();
	  }
	if(null != NCCommandChannel)
	  {
	    NCCommandChannel.disconnect();
	    NCCommandChannel.connect();
	  }
	if(null != NCErrlogChannel)
	  {
	    NCErrlogChannel.disconnect();
	    NCErrlogChannel.connect();
	  }
	is_connected = true;
	connectedCheckbox.setState(true);
	reconnect_needed = false;
      }
    catch(Exception e)
      {
	if(debug_on)
	  {
	    e.printStackTrace();
	  }
      }
    last_connect_try_time = System.currentTimeMillis();
  }

  String ftp_login_name =null;
  String ftp_login_passwd = null;
  String ftp_host_name=null;
  String ftp_file_info=null;
  EMC_TASK_PLAN_OPEN openMsg = new EMC_TASK_PLAN_OPEN();

public boolean SendFileToController(String file)
  {
    String out_file = null;
     if(run_local)
       {
	 if(null != NCCommandChannel)
	  {
	    file.getBytes(0,file.length(),openMsg.file,0);
	    openMsg.file[file.length()] = 0;
	    SetCmdToSend(openMsg,nml_emc.EMC_TASK_MODE_AUTO);
	  }
	 return true;
       }
    if(debug_on)
      {
	System.out.println("SendFileToController: m_NCProgBase="+m_NCProgBase);
	System.out.println("SendFileToController: file="+file);
      }
    if(null == file)
      {
	return true;
      }
    if(file.length() < 1)
      {
	return true;
      }
    if(null == m_NCProgBase)
      {
	return true;
      }
    if(m_NCProgBase.length() < 1)
      {
	return true;
      }
    String fileToCompare = file;
    String baseToCompare = m_NCProgBase;
    if(baseToCompare.indexOf('\\') > -1)
      {
	fileToCompare = file.toUpperCase();
	baseToCompare = m_NCProgBase.toUpperCase();
      }
    if(fileToCompare.startsWith(baseToCompare))
      {
	out_file = file.substring(m_NCProgBase.length());
	if(null != NCCommandChannel)
	  {
	    if(debug_on)
	      {
		System.out.println("out_file = "+out_file);
	      }
	    out_file.getBytes(0,out_file.length(),openMsg.file,0);
	    openMsg.file[out_file.length()] = 0;
	    SetCmdToSend(openMsg,nml_emc.EMC_TASK_MODE_AUTO);
	  }
	return true;
      }

    try
      {
	int  last_slash_index = file.lastIndexOf('/');
	int	 last_bslash_index = file.lastIndexOf('\\');
	if(last_bslash_index > last_slash_index)
	  {
	    last_slash_index = last_bslash_index;
	  }
	out_file = file.substring(last_slash_index+1);
			
			
	boolean is_ftp = false;
	URL prog_base_url = null;
	try
	  {
	    prog_base_url =new URL(m_NCProgBase);
			
	    if(prog_base_url.getProtocol().equalsIgnoreCase("ftp"))
	      {
		is_ftp = true;
	      }
	    ftp_host_name = prog_base_url.getHost();
	    ftp_file_info = prog_base_url.getFile();
	  }
	catch(Exception e)
	  {
	    if(m_NCProgBase.startsWith("ftp:"))
	      {
		is_ftp = true;
		ftp_host_name = GetHostNameFromURL(m_NCProgBase);
		ftp_file_info = GetFileInfoFromURL(m_NCProgBase);
	      }
	  }
			
	if(is_ftp)
	  {
	    FtpModule ftp_module = new FtpModule(null);
	    if(!ftp_module.connect(ftp_host_name))
	      {
		Alert("Can not connect to FTP server, "+ ftp_host_name);
		ftp_module.disconnect();
		return false;
	      }
	    if(null == parentFrame)
	      {
		try
		  {
		    parentFrame = (Frame) getParent();
		  }
		catch(ClassCastException e)
		  {
		    parentFrame = new Frame();
		  }
	      }
	    if(null == ftp_login_passwd || null == ftp_login_name)
	      {
		ftp_login_name = userNameField.getText();
		ftp_login_passwd = userPasswdField.getText();
		if(ftp_login_name.length() < 1)
		  {
		    ftp_login_name = null;
		    PasswdDialog pd = new PasswdDialog(parentFrame, "FTP Login to "+prog_base_url.getHost());
		    if(null == pd)
		      {
			ftp_module.disconnect();
			return false;
		      }
		    while(!pd.isDone())
		      {
			Thread.sleep(500);
		      }
		    ftp_login_name = pd.name;
		    ftp_login_passwd = pd.passwd;
		  }
	      }
	    if(null == ftp_login_name || null == ftp_login_passwd)
	      {
		ftp_module.disconnect();
		loginStatusLabel.setText("Not Logged In");
		loginStatusLabel.setBackground(Color.lightGray);
		return false;
	      }
	    while(!ftp_module.login(ftp_login_name,ftp_login_passwd))
	      {
		Alert("Login failed!");
		PasswdDialog pd = new PasswdDialog(parentFrame, "FTP Login to "+ftp_host_name);
		if(null == pd)
		  {
		    ftp_module.disconnect();
		    return false;
		  }
		while(!pd.isDone())
		  {
		    Thread.sleep(500);
		  }
		ftp_login_name = pd.name;
		ftp_login_passwd = pd.passwd;
		if(null == ftp_login_name || null == ftp_login_passwd)
		  {
		    ftp_module.disconnect();
		    loginStatusLabel.setText("Not Logged In");
		    loginStatusLabel.setBackground(Color.lightGray);
		    return false;
		  }
	      }
	    loginStatusLabel.setText(ftp_login_name+" Logged In");
	    loginStatusLabel.setBackground(Color.green);
	    if(!ftp_module.chdir(ftp_file_info))
	      {
		ftp_login_name = null;
		ftp_login_passwd = null;
		loginStatusLabel.setText("Not Logged In");
		loginStatusLabel.setBackground(Color.lightGray);
		ftp_module.disconnect();
		return false;
	      }
	    if(!ftp_module.sendFile(true,file,out_file))
	      {
		ftp_login_name = null;
		ftp_login_passwd = null;
		loginStatusLabel.setText("Not Logged In");
		loginStatusLabel.setBackground(Color.lightGray);
		ftp_module.disconnect();
		return false;
	      }
	    ftp_module.disconnect();
	  }
	else
	  {
	    if(m_NCProgBase.startsWith("http"))
	      {
		URL url = new URL(m_NCProgBase + out_file);
		URLConnection url_connection =  url.openConnection();
		OutputStream out_stream = url_connection.getOutputStream();
		DataOutputStream data_output_stream = new DataOutputStream(out_stream);
		URL_and_FileLoader loader = new URL_and_FileLoader(file);
		String line = loader.readLine();
		while(line != null)
		  {
		    data_output_stream.writeBytes(line);
		    line = loader.readLine();
		  }
	      }
	    else
	      {
		String file_to_write = m_NCProgBase + out_file;
		if(debug_on)
		  {
		    System.out.println("Writing "+file_to_write);
		  }
		FileOutputStream fos = new 	FileOutputStream(file_to_write);
		DataOutputStream data_output_stream = new DataOutputStream(fos);
		if(debug_on)
		  {
		    System.out.println("Reading "+file);
		  }
		URL_and_FileLoader loader = new URL_and_FileLoader(file);
		String line = loader.readLine();
		while(line != null)
		  {
		    if(debug_on)
		      {
			System.out.println(line);
		      }
		    data_output_stream.writeBytes(line+newline);
		    line = loader.readLine();
		  }
		loader.close();
		data_output_stream.close();
		data_output_stream = null;
		fos.close();
		fos = null;
	      }
	  }
	if(null != NCCommandChannel)
	  {
	    out_file.getBytes(0,out_file.length(),openMsg.file,0);
	    openMsg.file[out_file.length()] = 0;
	    SetCmdToSend(openMsg,nml_emc.EMC_TASK_MODE_AUTO);
	  }

      }
    catch(Exception e)
      {
	e.printStackTrace();
	return false;
      }
    return true;
  }


public boolean RunProgram(String file)
  {
		
    try
      {
	if(null == NCCommandChannel)
	  {
	    return false;
	  }
	if(!run_local)
	  {
	    if(file.startsWith(m_NCProgBase))
	      {
		file = file.substring(m_NCProgBase.length());
	      }
	    else
	      {
		int  last_slash_index = file.lastIndexOf('/');
		int	 last_bslash_index = file.lastIndexOf('\\');
		if(last_bslash_index > last_slash_index)
		  {
		    last_slash_index = last_bslash_index;
		  }
		file = file.substring(last_slash_index+1);
	      }
	  }
	  
       String curFile = null;
       if(ncStatus != null)
	 {
	   curFile = new String(ncStatus.task.file);
	 }
       else
	 {
	   curFile = new String(ncStatusOld.task.file);
	 }
	   
       if(true) // !curFile.equals(file))
	 {
	   file.getBytes(0,file.length(),openMsg.file,0);
	   openMsg.file[file.length()] = 0;
	   SetCmdToSend(openMsg,nml_emc.EMC_TASK_MODE_AUTO);
	   SendCommand();
	   WaitForDoneTimeout = 5.0;
	    start_waitfordone_millis = System.currentTimeMillis();
	    WaitForDoneNeeded = true;
	    file_to_run = file;
	    send_run_command_needed = true;
	   
	 }
	//file.getBytes(0,file.length(),runMsg.file,0);
		 
	return true;
      }
    catch(Exception e)
      {
	e.printStackTrace();
	return false;
      }
							
  }

  boolean send_run_command_needed = false;
  public String file_to_run = null;
  public void SendRunCommand()
  {
    SetCmdToSend(runMsg,nml_emc.EMC_TASK_MODE_AUTO);
    if(null != mdiOldCommandsArea)
      {
	if(choice_layout_selection.equals("program"))
	  {
	    mdiOldCommandsArea.appendText("( Run "+file_to_run+" )"+newline);
	  }
      }
    send_run_command_needed = false;
  }
	
public String BrowseLocalForFile(String title)
  {
    try
      {
	if(null == parentFrame)
	  {
	    try
	      {
		parentFrame = (Frame) getParent();
	      }
	    catch(ClassCastException e)
	      {
		parentFrame = new Frame();
	      }
	  }
	FileDialog fdialog = new FileDialog(parentFrame, title);
	if(null != m_NCProgBase)
	  {
	    if(!m_NCProgBase.startsWith("http") && !m_NCProgBase.startsWith("ftp"))
	      {
		fdialog.setDirectory(m_NCProgBase);
	      }
	  }
	fdialog.show();
	if(fdialog.getFile() == null)
	  {
	    return null;
	  }
	if(fdialog.getDirectory() == null)
	  {
	    return 	fdialog.getFile();
	  }
	return fdialog.getDirectory() + fdialog.getFile();
      }
    catch(Exception e)
      {
	e.printStackTrace();
	return null;
      }

  }

public static String GetHostNameFromURL(String url)
  {
    StringTokenizer tokenizer = new StringTokenizer(url,":/\\#?");
    if(!tokenizer.hasMoreTokens())
      {
	return null;
      }
    tokenizer.nextToken(); //throw the protocol string away
    if(!tokenizer.hasMoreTokens())
      {
	return null;
      }
    return tokenizer.nextToken();
  }

public static String GetFileInfoFromURL(String url)
  {
    int qindex = url.indexOf('?');
    if(qindex > 0)
      {
	url = url.substring(0,qindex);
      }
    int pindex = url.indexOf('#');
    if(pindex > 0)
      {
	url = url.substring(0,pindex);
      }
    int cindex = url.lastIndexOf(':');
    if(cindex > 0)
      {
	url = url.substring(cindex+1);
      }
    StringTokenizer tokenizer = new StringTokenizer(url,"/");
    if(!tokenizer.hasMoreTokens())
      {
	return null;
      }
    tokenizer.nextToken(); //throw the host or port string away
    String retval = "";
    while(tokenizer.hasMoreTokens())
      {
	retval += "/"+tokenizer.nextToken();
      }
    return retval;
  }

  boolean is_ftp = false;
  URL prog_base_url = null;
  FtpModule ftp_module = null;
  FTPBrowser ftp_dialog = null;
  int browse_remote_state = 0;
  PasswdDialog pd = null;
		
public String BrowseRemoteForFile(String title)
  {
    try
      {
	switch(browse_remote_state)
	  {
	  case 0:
	    try
	      {
		//System.out.println("new URL("+ m_NCProgBase+")");
		prog_base_url =new URL(m_NCProgBase);
				
		if(prog_base_url.getProtocol().equalsIgnoreCase("ftp"))
		  {
		    is_ftp = true;
		  }
		ftp_host_name = prog_base_url.getHost();
		ftp_file_info = prog_base_url.getFile();
	      }
	    catch(IOException e)
	      {
		if(m_NCProgBase.startsWith("ftp:"))
		  {
		    is_ftp = true;
		    ftp_host_name = GetHostNameFromURL(m_NCProgBase);
		    ftp_file_info = GetFileInfoFromURL(m_NCProgBase);
		  }
	      }
	    browse_remote_state = 1;
	    break;

	  case 1:
	    if(!is_ftp)
	      {
		browse_remote_state = 10;
		break;
	      }
	    //System.out.println("Creating FtpModule.");
	    ftp_module = new FtpModule(null);
	    if(null == ftp_module)
	      {
		return null;
	      }
	    //System.out.println("Connecting to "+ftp_host_name);
	    if(!ftp_module.connect(ftp_host_name))
	      {
		Alert("Can not connect to FTP server, "+ ftp_host_name);
		ftp_module.disconnect();
		return null;
	      }
	    //System.out.println("Getting parentFrame");
	    if(null == parentFrame)
	      {
		try
		  {
		    parentFrame = (Frame) getParent();
		  }
		catch(ClassCastException e)
		  {
		    parentFrame = new Frame();
		  }
	      }
	    if(null == ftp_login_passwd || null == ftp_login_name)
	      {
		//System.out.println("Getting login name and password.");
		if(null != userNameField && null !=  userPasswdField)
		  {
		    ftp_login_name = userNameField.getText();
		    ftp_login_passwd = userPasswdField.getText();
		  }
		if(null != ftp_login_name)
		  {
		    if(ftp_login_name.length() < 1)
		      {
			ftp_login_name = null;
			String pdtitle = "FTP Login to "+ftp_host_name;
			//System.out.println("Creating PasswdDialog("+parentFrame+", "+pdtitle+")");
			pd = new PasswdDialog(parentFrame,pdtitle );
			if(null == pd)
			  {
			    ftp_module.disconnect();
			    return null;
			  }
			if(!pd.isDone())
			  {
			    browse_remote_state = 2;
			    return null;
			  }
			ftp_login_name = pd.name;
			ftp_login_passwd = pd.passwd;
		      }
		  }
	      }
	    browse_remote_state = 3;
	    break;

	  case 2:
	    if(null == pd)
	      {
		System.err.println("Error in BrowseRemoteForFile. (pd == null)");
		browse_remote_requested = false;
		browse_remote_state = 0;
		ftp_module = null;
		ftp_dialog = null;
		pd = null;
		prog_base_url = null;
		return null;
	      }
	    if(pd.isDone())
	      {
		ftp_login_name = pd.name;
		ftp_login_passwd = pd.passwd;
		browse_remote_state = 3;
	      }
	    break;

	  case 3:
	    if(null == ftp_login_name || null == ftp_login_passwd)
	      {
		System.out.println("BrowseRemoteForFile canceled because login or passwd is null.");
		ftp_module.disconnect();
		loginStatusLabel.setText("Not Logged In");
		loginStatusLabel.setBackground(Color.lightGray);
		browse_remote_requested = false;
		browse_remote_state = 0;
		ftp_module = null;
		ftp_dialog = null;
		pd = null;
		prog_base_url = null;
		return null;
	      }
	    if(!ftp_module.login(ftp_login_name,ftp_login_passwd))
	      {
		Alert("Login to "+ftp_host_name+" failed!");
		pd = new PasswdDialog(parentFrame, "FTP Login to "+prog_base_url.getHost());
		if(null == pd)
		  {
		    ftp_module.disconnect();
		    browse_remote_requested = false;
		    browse_remote_state = 0;
		    ftp_module = null;
		    ftp_dialog = null;
		    pd = null;
		    prog_base_url = null;
		    return null;
		  }
		if(!pd.isDone())
		  {
		    browse_remote_state = 2;
		    return null;
		  }
		ftp_login_name = pd.name;
		ftp_login_passwd = pd.passwd;
		if(null == ftp_login_name || null == ftp_login_passwd)
		  {
		    if(debug_on)
		      {
			System.out.println("BrowseRemoteForFile canceled because login or passwd is null.");
		      }
		    ftp_module.disconnect();
		    loginStatusLabel.setText("Not Logged In");
		    loginStatusLabel.setBackground(Color.lightGray);
		    browse_remote_requested = false;
		    browse_remote_state = 0;
		    ftp_module = null;
		    ftp_dialog = null;
		    pd = null;
		    prog_base_url = null;
		    return null;
		  }
	      }
	    loginStatusLabel.setText(ftp_login_name +" Logged In");
	    loginStatusLabel.setBackground(Color.green);
	    if(!ftp_module.chdir(ftp_file_info))
	      {
		ftp_login_name = null;
		ftp_login_passwd = null;
		ftp_module.disconnect();
		loginStatusLabel.setText("Not Logged In");
		loginStatusLabel.setBackground(Color.lightGray);
		browse_remote_requested = false;
		browse_remote_state = 0;
		ftp_module = null;
		ftp_dialog = null;
		pd = null;
		prog_base_url = null;
		return null;
	      }
	    ftp_dialog = new FTPBrowser(parentFrame, title,ftp_module);
	    browse_remote_state = 4;
					
	  case 4:

	    if(!ftp_dialog.isDone())
	      {
		return null;
	      }
	    browse_remote_requested = false;
	    browse_remote_state = 0;
	    ftp_module.disconnect();
	    ftp_module = null;
	    pd = null;
	    prog_base_url = null;
	    if(null != ftp_dialog.file_chosen)
	      {
		return m_NCProgBase+ftp_dialog.file_chosen;
	      }
	    ftp_dialog = null;
	    return null;

	  case 10:
	    browse_remote_requested = false;
	    browse_remote_state = 0;
	    return null;
	  }
	return null;
      }
    catch(Exception e)
      {
	e.printStackTrace();
	browse_remote_requested = false;
	browse_remote_state = 0;
	if(null != ftp_module)
	  {
	    ftp_module.disconnect();
	  }
	ftp_module = null;
	pd = null;
	prog_base_url = null;
	return null;
      }

  }



  void LoadFileToProgramList(String file_name)
  {
    try
      {
	URL prog_base_url = null;
	URL_and_FileLoader loader = null;
	boolean is_ftp = false;
	FtpModule ftp_module = null;
	try
	  {
	    prog_base_url =new URL(file_name);
			
	    if(prog_base_url.getProtocol().equalsIgnoreCase("ftp"))
	      {
		is_ftp = true;
	      }
	    ftp_host_name = prog_base_url.getHost();
	    ftp_file_info = prog_base_url.getFile();
	  }
	catch(Exception e)
	  {
	    if(file_name.startsWith("ftp:"))
	      {
		is_ftp = true;
		ftp_host_name = GetHostNameFromURL(file_name);
		ftp_file_info = GetFileInfoFromURL(file_name);
	      }
	  }

	if(is_ftp)
	  {
			
	    ftp_module = new FtpModule(null);
	    if(!ftp_module.connect(ftp_host_name))
	      {
		Alert("Can not connect to FTP server, "+ ftp_host_name);
		ftp_module.disconnect();
		return;
	      }
	    if(null == parentFrame)
	      {
		try
		  {
		    parentFrame = (Frame) getParent();
		  }
		catch(ClassCastException e)
		  {
		    parentFrame = new Frame();
		  }
	      }
	    if(null == ftp_login_passwd || null == ftp_login_name)
	      {
		ftp_login_name = userNameField.getText();
		ftp_login_passwd = userPasswdField.getText();
		if(ftp_login_name.length() < 1)
		  {
		    ftp_login_name = null;
		    PasswdDialog pd = new PasswdDialog(parentFrame, "FTP Login to "+prog_base_url.getHost());
		    if(null == pd)
		      {
			ftp_module.disconnect();
			return;
		      }
		    while(!pd.isDone())
		      {
			Thread.sleep(500);
		      }
		    ftp_login_name = pd.name;
		    ftp_login_passwd = pd.passwd;
		  }
	      }
	    if(null == ftp_login_name || null == ftp_login_passwd)
	      {
		ftp_module.disconnect();
		loginStatusLabel.setText("Not Logged In");
		loginStatusLabel.setBackground(Color.lightGray);
		return;
	      }
	    while(!ftp_module.login(ftp_login_name,ftp_login_passwd))
	      {
		Alert("Login failed!");
		PasswdDialog pd = new PasswdDialog(parentFrame, "FTP Login to "+prog_base_url.getHost());
		if(null == pd)
		  {
		    ftp_module.disconnect();
		    return;
		  }
		while(!pd.isDone())
		  {
		    Thread.sleep(500);
		  }
		ftp_login_name = pd.name;
		ftp_login_passwd = pd.passwd;
		if(null == ftp_login_name || null == ftp_login_passwd)
		  {
		    loginStatusLabel.setText("Not Logged In");
		    loginStatusLabel.setBackground(Color.lightGray);
		    ftp_module.disconnect();
		    return;
		  }
	      }
	    loginStatusLabel.setText(ftp_login_name +" Logged In");
	    loginStatusLabel.setBackground(Color.green);
	    loader = new URL_and_FileLoader(ftp_module.getFileInputStream(ftp_file_info));
	  }
	else
	  {
	    loader = new URL_and_FileLoader(file_name);
	  }
	String line = null;
	programList.clear();
	repaint();
	while(null != (line = loader.readLine()))
	  {
	    programList.addItem(line);
	  }
	if(is_ftp && ftp_module != null)
	  {
	    ftp_module.disconnect();	
	  }
	StoreFileName(file_name);
      }
    catch(Exception e)
      {
	e.printStackTrace();
      }
  }

	
  //		The stop() method is called when the page containing the applet is
  // no longer on the screen. The AppletWizard's initial implementation of
  // this method stops execution of the applet's thread.
  //--------------------------------------------------------------------------
public void stop()
  {
    if (m_NCapplet != null)
      {
	m_NCapplet.stop();
	m_NCapplet = null;
      }
  }

  static int memWarnings = 0;
  public void MemoryCheck()
  {
    try
      {
	Runtime rt = Runtime.getRuntime();
	long free_mem = rt.freeMemory();
	if(free_mem < 50000)
	  {
	    if(0 == memWarnings % 1000)
	      {
		System.err.println("Warning: Free memory down to "+free_mem+" at "+new Date());
	      }
	    memWarnings++;
	  }
	rt.runFinalization();
	rt.gc();
      }
    catch(Exception e)
      {
	e.printStackTrace();
      }
  }
	

  // THREAD SUPPORT
  //		The run() method is called when the applet's thread is started. If
  // your applet performs any ongoing activities without waiting for user
  // input, the code for implementing that behavior typically goes here. For
  // example, for an applet that performs animation, the run() method controls
  // the display of images.
  //--------------------------------------------------------------------------
public void run()
  {
    while (true)
      {
	try
	  {
	    long stime = System.currentTimeMillis();
	    UpdateDisplay();
	    MemoryCheck();
	    long etime = System.currentTimeMillis();
	    double diff = (double) Math.abs((etime -stime)/1000.0);
	    int percent = (int) ( (diff/cycle_time) *100.0);
	    if(null != cycleTimeLabel)
	      {
		cycleTimeLabel.setText("Cycle Time: "+cycle_time+" ("+percent+"%)");
		if(percent < 70)
		  {
		    cycleTimeLabel.setBackground(Color.green);
		  }
		else if(percent < 90)
		  {
		    cycleTimeLabel.setBackground(Color.yellow);
		  }
		else
		  {
		    cycleTimeLabel.setBackground(Color.red);
		  }
	      }
	    Thread.sleep((long) (cycle_time*1000.0));
	  }
	catch (InterruptedException e)
	  {
	    stop();
	  }
      }
  }

  String interp_program_file = "";
  String old_interp_program_file = "";

public static String FormatDouble(double d, int length)
  {
    //System.out.println("FormatDouble("+d+", "+length+")");
    String str = Double.toString(d);
    //System.out.println("FormatDouble str = "+str);
    if(str.length() < length)
      {
	return str;
      }
    int eindex = str.indexOf('E');
    String exponent = "";
    //System.out.println("FormatDouble eindex = "+eindex);
    if(eindex > 0)
      {
	exponent = str.substring(eindex);
	str = str.substring(0,eindex);
      }
    else
      {
	int pindex = str.indexOf('.');
	//System.out.println("FormatDouble pindex = "+pindex);
	if(pindex > 2)
	  {
	    if(pindex > length -1)
	      {
		exponent = "E" + (pindex-1);
		str = str.charAt(0)+"."+str.substring(1,pindex) + str.substring(pindex+1);
	      }
	  }
	else
	  {
	    int exponent_int =0;
	    int i = 0;
	    for( i = 0; i < str.length(); i++)
	      {
		if(str.charAt(i) != '0' && 
		   str.charAt(i) != '.')
		  {
		    break;
		  }
		if(i > pindex)
		  {
		    exponent_int--;	
		  }
	      }
	    //System.out.println("FormatDouble exponent_int = "+exponent_int);
	    if(exponent_int < -3)
	      {
		exponent = "E"+exponent_int;
		//System.out.println("FormatDouble i = "+i);
		//System.out.println("FormatDouble str.charAt(i) = "+str.charAt(i));
		//System.out.println("FormatDouble str.substring(i+1) = "+str.substring(i+1));
		//System.out.println(	str.charAt(i)+'.'+str.substring(i+1));
		str = str.charAt(i)+"."+str.substring(i+1);
	      }
	  }
      }
    //System.out.println("FormatDouble str = "+str);
    //System.out.println("FormatDouble exponent = "+exponent);
    str = str.substring(0,(length - exponent.length()))+exponent;
    while(true)
      {
	char last_char = str.charAt(str.length() -1);
	int pindex = str.indexOf('.');
	if(last_char != ' ' && last_char != '.' &&
	   (last_char != '0' || pindex == -1))
	  {
	    break;
	  }
	str = str.substring(0, str.length()-1);
      }
    return str;
  }
  boolean first_stat_display = true;
  QueryDialog estop_query =null;
  QueryDialog machine_off_query =null;
  boolean machine_off_queried = false;
  boolean estop_queried = false;
			
  boolean foo = true;

  int num_homed = 0;
  String homed_string = "";
  int old_num_homed = 0;
  double xlocal = 0.0;
  double ylocal = 0.0;
  double zlocal = 0.0;
  double old_xlocal =0.0;
  double old_ylocal =0.0;
  double old_zlocal =0.0;

  long gui_heartbeat = 0;
  long task_heartbeat = 0;
  long motion_heartbeat = 0;
  long io_heartbeat = 0;

  int consecutive_nulls = 0;

  public void UpdateDisplay()
  {
    try
      {
	
	
	if(inside_init || loading_tool_table || !NMLInitialized)
	  {
	    return;
	  }

	if(reconnect_needed && System.currentTimeMillis() - last_connect_try_time > 1000)
	  {
	    ReconnectNML();
	    return;
	  }

	if(WaitForDoneNeeded)
	  {
	    if(!IsDone())
	      {
		return;
	      }
	  }

	

	//System.out.println("Update Display");
				
	if(load_program_requested)
	  {
	    load_program_requested = false;
	    String file = programTextField.getText();
	    if(!SendFileToController(file))
	      {
		Alert("Could not send file to controller!");
		return;
	      }
	    LoadFileToProgramList(file);
	    return;
	  }

	if(browse_local_requested)
	  {
	    browse_local_requested = false;
	    String file = BrowseLocalForFile("Open NC Program");
	    if(null != file)
	      {
		if(!SendFileToController(file))
		  {
		    Alert("Could not send file to controller!");
		    return;
		  }
		programTextField.setText(file);
		LoadFileToProgramList(file);
	      }
	    return;
	  }

	if(browse_remote_requested)
	  {
	    String file = BrowseRemoteForFile("Open NC Program");
	    if(null != file)
	      {
		browse_remote_requested = false;
		if(!SendFileToController(file))
		  {
		    Alert("Could not send file to controller!");
		    return;
		  }
		programTextField.setText(file);
		LoadFileToProgramList(file);
	      }
	    return;
	  }
			
	SendCommand();

	if(send_run_command_needed)
	  {
	    SendRunCommand();
	    return;
	  }


	/*
	if(null != machine_off_query)
	  {
	    if(machine_off_query.done)
	      {
		if(machine_off_query.ok)
		  {
		    stateMsg.state = nml_emc.EMC_TASK_STATE_ON;
		    SetCmdToSend(stateMsg, -1);
		  }
		machine_off_query = null;
		return;
	      }
	  }

	if(null != estop_query)
	  {
	    if(estop_query.done)
	      {
		if(estop_query.ok)
		  {
		    stateMsg.state = nml_emc.EMC_TASK_STATE_ESTOP_RESET;
		    SetCmdToSend(stateMsg, -1);
		  }
		estop_query = null;
		return;
	      }
	  }

	if(null != initQueryDialog)
	  {
	    if(initQueryDialog.done)
	      {
		if(initQueryDialog.ok)
		  {
		    SetCmdToSend(task_init_msg, -1);
		  }
		initQueryDialog = null;
		return;
	      }
	  }
	  */

	if(null != NCStatusChannel)
	  {
	    try
	      {
		ncStatus = (EMC_STAT) NCStatusChannel.read();
	      }
	    catch(NMLException e)
	      {
		is_connected = false;
		connectedCheckbox.setState(false);
		e.printStackTrace();
		NCStatusChannel = null;
		Alert("Can't read NC Status NML Channel.\n"+e.getMessage());
		reconnect_needed = true;
	      }
	  }
	if(null == ncStatus)
	  {
	    consecutive_nulls++;
	    if(consecutive_nulls >25)
	      {
		is_connected = false;
		connectedCheckbox.setState(false);
		reconnect_needed = true;
		consecutive_nulls = 0;
	      }
	  }
	if(null != ncStatus)
	  {
	    consecutive_nulls = 0;
	    if(load_tool_table_needed && !loading_tool_table)
	      {
		LoadToolTable();
	      }

	    //System.out.println("new status");
	    if(null == ncStatusOld)
	      {
		ncStatusOld = new EMC_STAT();
		first_stat_display = true;
		repaint_needed = true;
	      }
	    if(ncStatus.task.state != ncStatusOld.task.state ||
	       first_stat_display)
	      {
		repaint_needed = true;
		switch(ncStatus.task.state)
		  {
		  case  nml_emc.EMC_TASK_STATE_OFF:
		    powerStatusLabel.setBackground(Color.lightGray);
		    powerStatusLabel.setText("Machine Off");
		    /* if(!machine_off_queried)
		      {
			machine_off_query = Query("The Machine is OFF.\nPress OK to send the MACHINE_ON command.\nPress Cancel to leave the machine off.");
							
			machine_off_queried = true;
		      } */
		    break;

		  case  nml_emc.EMC_TASK_STATE_ON:
		    powerStatusLabel.setBackground(Color.white);
		    powerStatusLabel.setText("Machine On");
		    estopStatusLabel.setBackground(Color.lightGray);
		    estopStatusLabel.setText("E-Stop Reset");
		    estop_queried = false;
		    machine_off_queried = false;
		    break;

		  case  nml_emc.EMC_TASK_STATE_ESTOP:
		    powerStatusLabel.setBackground(Color.lightGray);
		    powerStatusLabel.setText("Machine Off");
		    if(m_UseColor)
		      {
			estopStatusLabel.setBackground(Color.red);
		      }
		    estopStatusLabel.setText("ESTOP");
		    /* 
		       if(!estop_queried)
		      {
			estop_query = Query("The Machine is in E-Stop.\nPress OK to send the ESTOP_RESET command.\nPress Cancel to remain in ESTOP.");
			estop_queried = true;
		      }
		      */
		    break;

		  case  nml_emc.EMC_TASK_STATE_ESTOP_RESET:
		    estopStatusLabel.setBackground(Color.lightGray);
		    estopStatusLabel.setText("E-Stop Reset");
		    /*
		      if(!machine_off_queried)
		      {
			machine_off_query = Query("The Machine is OFF.\nPress OK to send the MACHINE_ON command.\nPress Cancel to leave the machine off.");
							
			machine_off_queried = true;
		      }
		      */
		    break;
		  }
		ncStatusOld.task.state = ncStatus.task.state;
	      }
	     if(ncStatus.task.mode != ncStatusOld.task.mode ||
	       first_stat_display)
	      {
		repaint_needed = true;
		switch(ncStatus.task.mode)
		  {
		  case nml_emc.EMC_TASK_MODE_AUTO:
		    if(m_UseColor)
		      {
			modeStatusLabel.setBackground(Color.blue);
		      }
		    modeStatusLabel.setText("Auto Mode");
		    break;

		  case nml_emc.EMC_TASK_MODE_MDI:
		    if(m_UseColor)
		      {
			modeStatusLabel.setBackground(Color.magenta);
		      }
		    modeStatusLabel.setText("MDI Mode");
		    break;

		  case nml_emc.EMC_TASK_MODE_MANUAL:
		    if(m_UseColor)
		      {
			modeStatusLabel.setBackground(Color.cyan);
		      }
		    modeStatusLabel.setText("Manual Mode");
		    break;
		  }
		ncStatusOld.task.mode = ncStatus.task.mode;
	      }
	     
	      if(ncStatus.task.interpState != ncStatusOld.task.interpState ||
	       first_stat_display)
	      {
		repaint_needed = true;
		switch(ncStatus.task.interpState)
		  {
		  case nml_emc.EMC_TASK_INTERP_IDLE:
		    programStatusLabel.setBackground(Color.lightGray);
		    programStatusLabel.setText("Idle (Interp)");
		    break;

		  case nml_emc.EMC_TASK_INTERP_PAUSED:
		    if(m_UseColor)
		      {
			programStatusLabel.setBackground(Color.blue);
		      }
		    programStatusLabel.setText("Paused (Interp)");
		    break;

		  case nml_emc.EMC_TASK_INTERP_READING:
		    programStatusLabel.setBackground(Color.white);
		    programStatusLabel.setText("Reading (Interp)");
		    break;

		  case nml_emc.EMC_TASK_INTERP_WAITING:
		    if(m_UseColor)
		      {
			programStatusLabel.setBackground(Color.yellow);
		      }
		    programStatusLabel.setText("Waiting (Interp)");
		    break;
		  }
		ncStatusOld.task.interpState = ncStatus.task.interpState;
	      }
	    if(ncStatus.task.execState != ncStatusOld.task.execState ||
	       first_stat_display)
	      {
		repaint_needed = true;
		switch(ncStatus.task.execState)
		  {
		  case nml_emc.EMC_TASK_EXEC_ERROR:
		    if(m_UseColor)
		      {
			execStatusLabel.setBackground(Color.red);
		      }
		    execStatusLabel.setText("Exec Error");
		    break;	

		  case nml_emc.EMC_TASK_EXEC_DONE:
		    execStatusLabel.setBackground(Color.lightGray);
		    execStatusLabel.setText("Exec Done");
		    break;

		  case nml_emc.EMC_TASK_EXEC_WAITING_FOR_IO:
		    if(m_UseColor)
		      {
			execStatusLabel.setBackground(Color.yellow);
		      }
		    execStatusLabel.setText("Wait for IO");
		    break;

		  case nml_emc.EMC_TASK_EXEC_WAITING_FOR_MOTION:
		    if(m_UseColor)
		      {
			execStatusLabel.setBackground(Color.orange);
		      }
		    execStatusLabel.setText("Wait for Motion");
		    break;
		  }
		ncStatusOld.task.execState = ncStatus.task.execState;
	      }
	    if(ncStatus.motion.traj.inpos != ncStatusOld.motion.traj.inpos ||
	       first_stat_display)
	      {
		repaint_needed = true;
		if(ncStatus.motion.traj.inpos != 0)
		  {
		    inposStatusLabel.setBackground(Color.white);
		    inposStatusLabel.setText("In Position");
		  }
		else
		  {
		    inposStatusLabel.setBackground(Color.lightGray);
		    inposStatusLabel.setText("NOT in Position");
		  }
		ncStatusOld.motion.traj.inpos = ncStatus.motion.traj.inpos;
	      }
	    ncStatusOld.motion.axis[0].units = ncStatus.motion.axis[0].units;
	    ncStatusOld.motion.axis[1].units = ncStatus.motion.axis[1].units;
	    ncStatusOld.motion.axis[2].units = ncStatus.motion.axis[2].units;
	    if(ncStatusOld.motion.axis[0].enabled != ncStatus.motion.axis[0].enabled || first_stat_display)
	      {
		repaint_needed = true;
		ncStatusOld.motion.axis[0].enabled = ncStatus.motion.axis[0].enabled;
		XEnableCheckbox.setState((boolean) (ncStatus.motion.axis[0].enabled != 0));
	      }
	    if(ncStatusOld.motion.axis[1].enabled != ncStatus.motion.axis[1].enabled || first_stat_display)
	      {
		repaint_needed = true;
		ncStatusOld.motion.axis[1].enabled = ncStatus.motion.axis[1].enabled;
		YEnableCheckbox.setState((boolean) (ncStatus.motion.axis[1].enabled != 0));
	      }
	    if(ncStatusOld.motion.axis[2].enabled != ncStatus.motion.axis[2].enabled || first_stat_display)
	      {
		repaint_needed = true;
		ncStatusOld.motion.axis[2].enabled = ncStatus.motion.axis[2].enabled;
		ZEnableCheckbox.setState((boolean) (ncStatus.motion.axis[2].enabled != 0));
	      }
	    if(ncStatusOld.io.spindle.brake != ncStatus.io.spindle.brake || first_stat_display)
	      {
		repaint_needed = true;
		ncStatusOld.io.spindle.brake = ncStatus.io.spindle.brake;
		spindleBrakeCheckbox.setState((boolean) (ncStatus.io.spindle.brake != 0));
	      }
		
	    

	    if(ncStatus.motion.traj.velocity != ncStatusOld.motion.traj.velocity  ||
	       ncStatus.motion.traj.scale != ncStatusOld.motion.traj.scale  ||
		   first_stat_display)
	      {
		repaint_needed = true;
		feedrateStatusLabel.setText("Feed "+FormatDouble(ncStatus.motion.traj.velocity,5));
		feedrateOverrideLabel.setText("Feedrate Override: "+ ncStatus.motion.traj.scale*100+"%");
		feedrateOverrideSlider.setValue((int) (ncStatus.motion.traj.scale*100));
	      }
	    if(ncStatus.io.spindle.speed != ncStatusOld.io.spindle.speed  ||
	      ncStatus.io.spindle.direction != ncStatusOld.io.spindle.direction  ||
	       first_stat_display)
	      {
		repaint_needed = true;
		spindleStatusLabel.setText("Speed "+FormatDouble(ncStatus.io.spindle.speed,5));
		if(m_UseColor)
		  {
		    if(ncStatus.io.spindle.direction > 1E-3)
		      {
			spindleStatusLabel.setBackground(Color.cyan);
		      }
		    else if (ncStatus.io.spindle.direction < -1E-3) 
		      {
			spindleStatusLabel.setBackground(Color.magenta);
		      }
		    else
		      {
			spindleStatusLabel.setBackground(Color.lightGray);
		      }
		  }
	      }
	    /*
		if(ncStatus.io.speed_override != ncStatusOld.io.speed_override  ||
		   first_stat_display)
		  {
		    spindleOverrideLabel.setText("Spindle Override: "+ ncStatus.io.speed_override*100+"%");
		    spindleOverrideSlider.setValue((int) (ncStatus.io.speed_override*100));
		  }
	      }
	      */
	    num_homed = 0;
	    if(ncStatus.motion.axis[0].homed != 0)
	      {
		num_homed++;
	      }
	    if(ncStatus.motion.axis[1].homed != 0)
	      {
		num_homed++;
	      }
	    if(ncStatus.motion.axis[2].homed != 0)
	      {
		num_homed++;
	      }
	    homed_string ="";
	    if(num_homed != old_num_homed || first_stat_display)
	      {
		repaint_needed = true;
		old_num_homed = num_homed;
		if(ncStatus.motion.axis[0].homed != 0)
		  {
		    homed_string +="X";
		  }
		if(ncStatus.motion.axis[1].homed != 0)
		  {
		    homed_string +="Y";
		  }
		if(ncStatus.motion.axis[2].homed != 0)
		  {
		    homed_string +="Z";
		  }
		if(num_homed >= 3)
		  {
		    if(m_UseColor)
		      {
			homedStatusLabel.setBackground(Color.green);
		      }
		    homedStatusLabel.setText(homed_string+" homed");
		  }
		else if(num_homed > 0)
		  {
		    if(m_UseColor)
		      {
			homedStatusLabel.setBackground(Color.yellow);
		      }
		    homedStatusLabel.setText(homed_string+" homed");
		  }
		else
		  {
		    if(m_UseColor)
		      {
			homedStatusLabel.setBackground(Color.red);
		      }
		    homedStatusLabel.setText("None homed");
		  }
	      }
	     boolean file_changed = false;
	    for(int ii = 0; ii < ncStatus.task.file.length; ii++)
	      {
		if(ncStatusOld.task.file[ii] != ncStatus.task.file[ii])
		  {
		    file_changed = true;
		    ncStatusOld.task.file[ii] = ncStatus.task.file[ii];
		  }
		if(ncStatus.task.file[ii] == 0)
		  {
		    break;
		  }
	      }
	    if(file_changed || first_stat_display)
	      {
		repaint_needed = true;
		interp_program_file = NMLBytesToString(ncStatus.task.file);
		if(null != interp_program_file && ncStatus.task.mode == nml_emc.EMC_TASK_MODE_AUTO)
		  {
		    if(interp_program_file.length() > 0 && 
		       !interp_program_file.equals(" +0") && 
		       !interp_program_file.equals("+0") && 
		       !interp_program_file.equals("-1") && 
		       !interp_program_file.equals(" -1")  )
		      {
			if(0 != CompareTails(interp_program_file, old_interp_program_file) 
			   && 0 != CompareTails(interp_program_file, programTextField.getText()))
			  {
			    String complete_name = CompleteTail(interp_program_file);
			    programTextField.setText(complete_name);
			    LoadFileToProgramList(complete_name);
			  }
		      }
		  }
	      }
	    if(ncStatus.task.currentLine != ncStatusOld.task.currentLine ||
	       ncStatus.task.motionLine != ncStatusOld.task.motionLine ||
	       first_stat_display)
	      {
		repaint_needed = true;
		int selectedIndexes[] = programList.getSelectedIndexes();
		for(int i = 0; i < selectedIndexes.length; i++)
		  {
		    programList.deselect(selectedIndexes[i]);
		  }
		if(ncStatus.task.currentLine > 0 && ncStatus.task.currentLine < programList.countItems())
		  {
		    programList.select(ncStatus.task.currentLine -1);
		  }
		if(ncStatus.task.motionLine > 0 && ncStatus.task.motionLine < programList.countItems())
		  {
		    programList.select(ncStatus.task.motionLine -1);
		    programList.makeVisible(ncStatus.task.motionLine -1);
		  }
		//		ncStatusOld.interp.line = ncStatus.interp.line;
		ncStatusOld.task.currentLine = ncStatus.task.currentLine;
		ncStatusOld.task.motionLine = ncStatus.task.motionLine;
	      } 
            /* 
	    if((ncStatus.interp.single_block != ncStatusOld.interp.single_block ||
		first_stat_display) && m_UseColor)
	      {
		repaint_needed = true;
		if(ncStatus.interp.single_block != 0)
		  {
		    singleStepButton.setBackground(Color.yellow);
		  }
		else
		  {
		    singleStepButton.setBackground(Color.lightGray);
		  }
		ncStatusOld.interp.single_block = ncStatus.interp.single_block;
	      }
	      */
	    old_interp_program_file = interp_program_file;
	    ncStatusOld.motion.traj.velocity = ncStatus.motion.traj.velocity;
	    ncStatusOld.motion.traj.scale = ncStatus.motion.traj.scale;

	    ncStatusOld.io.spindle.speed = ncStatus.io.spindle.speed;
	    ncStatusOld.io.spindle.direction = ncStatus.io.spindle.direction;
	    //	    ncStatusOld.io.speed_override = ncStatus.io.speed_override;
	    // ncStatusOld.io.speed_override_disabled = ncStatus.io.speed_override_disabled;
	    ncStatusOld.motion.traj.position.tran.x = ncStatus.motion.traj.position.tran.x;
	    ncStatusOld.motion.traj.position.tran.y = ncStatus.motion.traj.position.tran.y;
	    ncStatusOld.motion.traj.position.tran.y = ncStatus.motion.traj.position.tran.y;
	    if(relative_position)
	      {
		xlocal = ncStatus.motion.traj.position.tran.x - ncStatus.task.origin.tran.x;
		ylocal = ncStatus.motion.traj.position.tran.y - ncStatus.task.origin.tran.y;
		zlocal = ncStatus.motion.traj.position.tran.z - ncStatus.task.origin.tran.z;
	      }
	    else
	      {
		xlocal = ncStatus.motion.traj.position.tran.x - x_local_offset;
		ylocal = ncStatus.motion.traj.position.tran.y - y_local_offset;
		zlocal = ncStatus.motion.traj.position.tran.z - z_local_offset;
	      }
	    xlocal /= ncStatus.motion.traj.linearUnits;
	    ylocal /= ncStatus.motion.traj.linearUnits;
	    zlocal /= ncStatus.motion.traj.linearUnits;
	    double xorigin = ncStatus.task.origin.tran.x/ ncStatus.motion.traj.linearUnits;

	    double yorigin = ncStatus.task.origin.tran.y/ ncStatus.motion.traj.linearUnits;

	    double zorigin = ncStatus.task.origin.tran.z/ ncStatus.motion.traj.linearUnits;
	    if(xlocal != old_xlocal ||
	       ylocal != old_ylocal ||
	       zlocal != old_zlocal ||
	       old_unit_type != unit_type  ||
	       first_stat_display)
	      {
		repaint_needed = true;
		old_xlocal = xlocal;
		old_ylocal = ylocal;
		old_zlocal = zlocal;
		old_unit_type = unit_type;
		if(unit_type == INCH_UNITS)
		  {
		    XPositionLabel.setText("X: "+FormatDouble(xlocal*MILLIMETERS_TO_INCHES,7)+" in.");
		    YPositionLabel.setText("Y: "+FormatDouble(ylocal*MILLIMETERS_TO_INCHES,7)+" in.");
		    ZPositionLabel.setText("Z: "+FormatDouble(zlocal*MILLIMETERS_TO_INCHES,7)+" in.");
		    XProgPosLabel.setText("X: "+FormatDouble(xlocal*MILLIMETERS_TO_INCHES,7)+" in.");
		    YProgPosLabel.setText("Y: "+FormatDouble(ylocal*MILLIMETERS_TO_INCHES,7)+" in.");
		    ZProgPosLabel.setText("Z: "+FormatDouble(zlocal*MILLIMETERS_TO_INCHES,7)+" in.");
		    XProgOffsetLabel.setText("X Offset: "+FormatDouble(xorigin*MILLIMETERS_TO_INCHES,7)+" in.");
		    YProgOffsetLabel.setText("Y Offset: "+FormatDouble(yorigin*MILLIMETERS_TO_INCHES,7)+" in.");
		    ZProgOffsetLabel.setText("Z Offset: "+FormatDouble(zorigin*MILLIMETERS_TO_INCHES,7)+" in.");
		  }
		else
		  {
		    XPositionLabel.setText("X: "+FormatDouble(xlocal,7)+" mm.");
		    YPositionLabel.setText("Y: "+FormatDouble(ylocal,7)+" mm.");
		    ZPositionLabel.setText("Z: "+FormatDouble(zlocal,7)+" mm.");
		    XProgPosLabel.setText("X: "+FormatDouble(xlocal,7)+" mm.");
		    YProgPosLabel.setText("Y: "+FormatDouble(ylocal,7)+" mm.");
		    ZProgPosLabel.setText("Z: "+FormatDouble(zlocal,7)+" mm.");
		    XProgOffsetLabel.setText("X Offset: "+FormatDouble(xorigin,7)+" mm.");
		    YProgOffsetLabel.setText("Y Offset: "+FormatDouble(yorigin,7)+" mm.");
		    ZProgOffsetLabel.setText("Z Offset: "+FormatDouble(zorigin,7)+" mm.");
		  }

		positionPanel.unit_type = unit_type;
		positionPanel.x = xlocal;
		positionPanel.y = ylocal;
		positionPanel.z = zlocal;
		positionPanel.UpdateStrings();
		positionPanel.repaint();
	      }
	    if(ncStatus.echo_serial_number > nc_serial_number)
	      {
		nc_serial_number = ncStatus.echo_serial_number;
	      }
	    if(repaint_needed) 
	      {
		repaint();
		repaint_needed = false;
	      }
	    first_stat_display = false;
	    num_stat_updates++;
	    gui_heartbeat++;
	    task_heartbeat = ncStatus.task.heartbeat;
	    io_heartbeat = ncStatus.io.heartbeat;
	    motion_heartbeat = ncStatus.motion.heartbeat;
	    GuiHeartBeatLabel.setText("GUI: "+gui_heartbeat);
	    TaskHeartBeatLabel.setText("TASK: "+task_heartbeat);
	    IoHeartBeatLabel.setText("IO: "+io_heartbeat);
	    MotionHeartBeatLabel.setText("MOTION: "+motion_heartbeat);
	    
	  }
	 if(null != NCErrlogChannel && read_errlog) 
	  {
	    NMLmsg errMsg = null;
	    try
	      {
		errMsg = NCErrlogChannel.read();
	      }
	    catch(NMLException NMLe)
	      {
		is_connected = false;
		connectedCheckbox.setState(false);
		NMLe.printStackTrace();
		NCErrlogChannel = null;
		Alert("Can't read Error Log NML Channel.\n"+NMLe.getMessage());
	      }
	    if(null != errMsg)
	      {
		if(debug_on)
		  {
		    System.out.println("New errMsg");
		  }
		switch(errMsg.type)
		  {
		  case nml_emc.EMC_OPERATOR_ERROR_TYPE:
		    DisplayOperatorError((EMC_OPERATOR_ERROR) errMsg);
		    break;

		  case errlogMsgDict.NML_ERROR_TYPE:
		    DisplayError((NML_ERROR) errMsg);
		    break;

		  case errlogMsgDict.NML_TEXT_TYPE:
		    DisplayText((NML_TEXT) errMsg);
		    break;

		  case errlogMsgDict.NML_DISPLAY_TYPE:
		    DisplayURL((NML_DISPLAY) errMsg);
		    break;
		  }
	      }
	  }
      }
    catch(Throwable e)
      {
	e.printStackTrace();
      }
  }

  Hashtable  tailsToURLsTable = null;

  String NMLBytesToString(byte b[])
  {
    try
      {
	String str = new String(b,0);
	//System.out.println("NMLBytesToString("+str+") called.");
	int sindex = str.indexOf(0);
	if(sindex > 0)
	  {
	    str = str.substring(0,sindex);
	  }
	if(str.equalsIgnoreCase("(null)") || 
	   str.equalsIgnoreCase("null")  || 
	   str.equals(" +0")  || 
	   str.equals(" -1")   )
	  {
	    //System.out.println("NMLBytesToString returning null.");
	    return null;
	  }
	//System.out.println("NMLBytesToString returning "+str);
	return str;
      }
    catch(Exception e)
      {
	e.printStackTrace();
      }
    return null;
  }

private void StoreFileName(String file_name)
  {
    if(null == tailsToURLsTable)
      {
	tailsToURLsTable = new Hashtable();
      }
    tailsToURLsTable.put(TailOnly(file_name), file_name);
  }

private String CompleteTail(String tail)
  {
    try
      {
	URL_and_FileLoader loader = new URL_and_FileLoader(tail);
	if(null != loader)
	  {
	    if(loader.TryNameSucceeded)
	      {
		return loader.StringToSucceed;
	      }
	  }
	if(null != tailsToURLsTable)
	  {
	    String url = (String) tailsToURLsTable.get(TailOnly(tail));
	    if(null != url)
	      {
		return url;
	      }
	  }
	loader = new URL_and_FileLoader(m_NCProgBase+tail);
	if(null != loader)
	  {
	    if(loader.TryNameSucceeded)
	      {
		return loader.StringToSucceed;
	      }
	  }
	loader = new URL_and_FileLoader(m_NCProgBase+TailOnly(tail));
	if(null != loader)
	  {
	    if(loader.TryNameSucceeded)
	      {
		return loader.StringToSucceed;
	      }
	  }
      }
    catch(Exception e)
      {
	e.printStackTrace();
      }
    if(tail.startsWith(m_NCProgBase))
      {
	return tail;
      }
    return m_NCProgBase+tail;
  }



private String TailOnly(String file)
  {
    try
      {
	if(null == file)
	  {
	    return "";
	  }
	String copy = new String(file);
	int sindex = copy.lastIndexOf('/');
	if(sindex >= 0)
	  {
	    if(sindex == copy.length())
	      {
		return "";
	      }
	    copy = copy.substring(sindex+1);
	  }
	sindex = copy.lastIndexOf('\\');
	if(sindex >= 0)
	  {
	    if(sindex == copy.length())
	      {
		return "";
	      }
	    copy = copy.substring(sindex+1);
	  }
	return copy;
      }
    catch(Exception e)
      {
	e.printStackTrace();
	return "";
      }
  }

private int CompareTails(String file1, String file2)
  {
    try
      {
	if(null == file1 && null == file2)
	  {
	    return 0;
	  }
	if(null == file1)
	  {
	    return -1;
	  }
	if(null == file2)
	  {
	    return 1;
	  }
	String Tail1 = TailOnly(file1);
	String Tail2 = TailOnly(file2);
	return Tail1.compareTo(Tail2);
      }
    catch(Exception e)
      {
	e.printStackTrace();
	return 0;
      }
  }



private boolean NewCodes(int codes[], int old_codes[])
  {
    try
      {
	boolean retval = false;
	boolean nonzero = false;
	for(int i = 0; i < codes.length; i++)
	  {
	    if(codes[i] != 0)
	      {
		nonzero = true;
		break;
	      }
	  }
	if(!nonzero)
	  {
	    return false;
	  }
	for(int i = 0; i < codes.length && i < old_codes.length; i++)
	  {
	    if(codes[i] != old_codes[i])
	      {
		retval = true;
	      }
	    old_codes[i] = codes[i];
	  }
	return retval;
      }
    catch(Exception e)
      {
	e.printStackTrace();
	return false;
      }
  }


public static String ReplaceEscapeChars(String str)
  {
    try
      {
	int escape_char_index = str.indexOf('\\');
	while(escape_char_index >= 0)
	  {
	    String first_part = str.substring(0,escape_char_index);
	    String second_part = "";
	    if(escape_char_index+2 < str.length())
	      {
		second_part = str.substring(escape_char_index+2);
	      }
	    char escape_char = str.charAt(escape_char_index+1);
	    char replace_char = escape_char;
	    switch(escape_char)
	      {
	      case 'n':
		replace_char = '\n';
		break;

	      case 'r':
		replace_char = 0;
		break;

	      case '0':
	      case '1':
	      case '2':
		String escape_string = str.substring(escape_char_index+1,escape_char_index+4);
		int replace_int = Integer.parseInt(escape_string);
		//System.out.println("escape_string = "+escape_string);
		//System.out.println("replace_int = "+replace_int);
		replace_char = (char) replace_int;
		second_part = second_part.substring(2);
		break;


	      }
	    /*System.out.println("str = "+str);
	      System.out.println("escape_char_index = "+escape_char_index);
	      System.out.println("first_part = "+first_part);
	      System.out.println("second_part = "+second_part);
	      System.out.println("escape_char = "+escape_char);
	      System.out.println("replace_char = "+replace_char);
	      */

	    if(replace_char > 0)
	      {
		str =  first_part + replace_char + second_part;
	      }
	    else
	      {
		str = first_part + second_part;
	      }
	    escape_char_index = str.indexOf('\\');
	  }
      }
    catch(Exception e)
      {
	System.err.println("Error replacing escape characters in "+str);
	e.printStackTrace();
      }
    return str;
  }

public static int convertStrToInt(String str) throws NumberFormatException
  {
    int multiplier = 1;
    StringTokenizer tokenizer = new StringTokenizer(str," \t\r\n\b:;[]()+");
    while(tokenizer.hasMoreTokens())
      {
	multiplier = 1;
	String token = tokenizer.nextToken();
	if(null == token)
	  {	
	    throw new NumberFormatException(str);
	  }
	if(token.startsWith("-"))
	  {
	    multiplier = -1;
	    token = token.substring(1);
	  }
	int point_index = token.indexOf(".");
	if(point_index > 0)
	  {
	    token = token.substring(0,point_index);
	  } else if(point_index == 0)
	    {
	      return 0;
	    }
	try
	  {
	    if(token.startsWith("0x"))
	      {
		return multiplier * Integer.parseInt(token.substring(2), 16);
	      }
	    else if(token.startsWith("0") && !token.equals("0"))
	      {
		return multiplier * Integer.parseInt(token.substring(1), 8);
	      }
	    else
	      {
		return multiplier * Integer.parseInt(token);
	      }
	  }
	catch(NumberFormatException e)
	  {
	    continue;
	  }		
      }
    throw new NumberFormatException(str);		
  }


public void DisplayError(NML_ERROR errMsg)
  {
    String msgString = NMLBytesToString(errMsg.error);
    msgString = ReplaceEscapeChars(msgString);
    int command_index = msgString.toUpperCase().indexOf("COMMAND");
    if(command_index > -1)
      {
	try
	  {
	    int cmdNum = convertStrToInt(msgString.substring(command_index+8));
	    if(cmdNum > 0)
	      {
		String cmdString = nml_emc.SymbolLookup(cmdNum);
		if(cmdString != null)
		  {
		    msgString = msgString.substring(0,command_index+8)+" "+cmdString+": "+msgString.substring(command_index+8);
		  }
	      }
	  }
	catch(Exception e)
	  {
	  }
      }
    String errorString = "( "+msgString+" )"+newline;
    errlogTextArea.appendText(errorString);
    if(null != mdiOldCommandsArea)
      {
	if(choice_layout_selection.equals("program"))
	  {
	    mdiOldCommandsArea.appendText(errorString);
	  }
      }
    num_errors++;
    num_new_errors++;
    if(m_UseColor)
      {
	errlogStatusLabel.setBackground(Color.red);
      }
    errlogStatusLabel.setText(num_errors+" errors ("+num_new_errors+" new)");
  }


  public void DisplayOperatorError(EMC_OPERATOR_ERROR errMsg)
  {
    String msgString = NMLBytesToString(errMsg.error);
    msgString = ReplaceEscapeChars(msgString);
    int command_index = msgString.toUpperCase().indexOf("COMMAND");
    if(command_index > -1)
      {
	try
	  {
	    int cmdNum = convertStrToInt(msgString.substring(command_index+8));
	    if(cmdNum > 0)
	      {
		String cmdString = nml_emc.SymbolLookup(cmdNum);
		if(cmdString != null)
		  {
		    msgString = msgString.substring(0,command_index+8)+" "+cmdString+": "+msgString.substring(command_index+8);
		  }
	      }
	  }
	catch(Exception e)
	  {
	  }
      }
    String errorString = "( "+msgString+" )"+newline;
    errlogTextArea.appendText(errorString);
    if(null != mdiOldCommandsArea)
      {
	if(choice_layout_selection.equals("program"))
	  {
	    mdiOldCommandsArea.appendText(errorString);
	  }
      }
    num_errors++;
    num_new_errors++;
    if(m_UseColor)
      {
	errlogStatusLabel.setBackground(Color.red);
      }
    errlogStatusLabel.setText(num_errors+" errors ("+num_new_errors+" new)");
  }


public void DisplayText(NML_TEXT textMsg)
  {
    String msgString = NMLBytesToString(textMsg.text);
    msgString = ReplaceEscapeChars(msgString);
    errlogTextArea.appendText("\nTEXT:  (Recieved on "+new Date()+" )\n"+msgString);
  }


public void DisplayURL(NML_DISPLAY displayMsg)
  {


  }
}
