//******************************************************************************
// NCappletFrame.java:	
//
//******************************************************************************
package emc.gui;

import java.awt.*;
import java.applet.Applet;


//==============================================================================
// STANDALONE APPLICATION SUPPORT
// 	This frame class acts as a top-level window in which the applet appears
// when it's run as a standalone application.
//==============================================================================
class NCappletFrame extends Frame
{
	Applet 	innerApplet = null;
	Dimension prevSize = null;
	static int nc_applet_frames = 0;
	static public boolean in_an_applet = false;
        static public boolean debug_on = false;

	// NCappletFrame constructor
	//--------------------------------------------------------------------------
	public NCappletFrame(String str, Applet inner_applet)
	{
		super (str);
		innerApplet = inner_applet;
		prevSize = size();
		nc_applet_frames++;
	}

        boolean resizing = false;

	public void resizeInnerApplet()
	{
	  if(resizing)
	    {
	      return;
	    }
	  resizing = true;
		Dimension d = size();
		int new_width = d.width;
		int new_height = d.height;
		if(new_width < 640 || new_height < 460)
		{
			if(new_width < 640)
			{
				new_width = 640;
			}
			if(new_height < 460)
			{
				new_height = 460;
			}
			resize(new_width,new_height);
		}
		if(Math.abs(prevSize.width - new_width) > 5 ||
			Math.abs(prevSize.height - new_height) > 5)
		{
			invalidate();
			if(debug_on)
			  {
			    System.out.println("NCappletFrame resizing to "+new_width+"X"+new_height);
			  }
			removeAll();
			Insets is = insets();
			if(is.right < 10)
			{
				is.right = 10;
			}
			if(is.left < 10)
			{
				is.left = 10;
			}
			if(is.top < 10)
			{
				is.top = 10;
			}
			if(is.bottom < 10)
			{
				is.bottom = 10;
			}
			if(rcs.utils.BrowserInfo.IsNetscapeFourOrLater())
			{
				is.bottom += 30;
			}
			if(null != innerApplet)
			{
				innerApplet.resize(new_width - is.right - is.left, 
									new_height - is.top - is.bottom);
				add("Center",innerApplet);
			}
			validate();
			repaint();
		}
		prevSize = new Dimension(new_width, new_height);
		resizing = false;
	}


	// The handleEvent() method receives all events generated within the frame
	// window. You can use this method to respond to window events. To respond
	// to events generated by menus, buttons, etc. or other controls in the
	// frame window but not managed by the applet, override the window's
	// action() method.
	//--------------------------------------------------------------------------
	public boolean handleEvent(Event evt)
	{
		//System.out.println("evt.id = "+evt.id);
		switch (evt.id)
		{
			// Application shutdown (e.g. user chooses Close from the system menu).
			//------------------------------------------------------------------
			case Event.WINDOW_DESTROY:
				dispose();
				nc_applet_frames--;
				if(nc_applet_frames <= 0 && !in_an_applet)
				{
					System.exit(0);
				}
				return true;

			case Event.WINDOW_MOVED:
				resizeInnerApplet();
				return super.handleEvent(evt);
		
			case Event.WINDOW_DEICONIFY:
				resizeInnerApplet();
				return super.handleEvent(evt);
		

			case Event.MOUSE_ENTER:
				resizeInnerApplet();
				return super.handleEvent(evt);
		
			case Event.MOUSE_EXIT:
				resizeInnerApplet();
				return super.handleEvent(evt);
		


			default:
				return super.handleEvent(evt);
		}			 
	}
}
