package emc.gui;

import java.awt.*;

/*
 *
 * PositionDisplayPanel
 *
 */
public class PositionDisplayPanel extends Panel
{
  Dimension d = null;
  public String units;
  public double x;
  public double y;
  public double z;
  static public final int INCH_UNITS = 1;
  static public final int MILLIMETER_UNITS = 2;
  static public final double MILLIMETERS_TO_INCHES = (1/25.4);
  static public final double INCHES_TO_MILLIMETERS = 25.4;
  int unit_type = INCH_UNITS;

  Font new_font = null;

  PositionDisplayPanel(int width, int height)
  {
    super();
    d = new Dimension(width,height);
    //resize(width,height);
    setBackground(Color.black);
    try
      {
	Graphics g = getGraphics();
	String font_name = "Helvetica";
	if(null == d)
	  {
	    System.out.println("PositionDisplayPanel: d = null\n");
	    return;
	  }
		
	if(d.width < 800)
	  {
	    Font new_font = new Font(font_name,Font.PLAIN,60);
	    if(null == new_font)
	      {
		System.out.println("PositionDisplayPanel: new_font = null\n");
		return;
	      }
	    if(null != g)
	      {
		g.setFont(new_font);
	      }
	    setFont(new_font);
	    lineheight = 60;
	  }
	else
	  {
	    Font new_font = new Font(font_name,Font.PLAIN,100);
	    if(null == new_font)
	      {
		System.out.println("PositionDisplayPanel.paint(): new_font = null\n");
		return;
	      }
	    if(null != g)
	      {
		g.setFont(new_font);
	      }
	    setFont(new_font);
	  }

      }
    catch(Exception e)
      {
	e.printStackTrace();
      }
  }

  public Dimension preferredSize()
  {
    return d;
  }

  public Dimension minimumSize()
  {
    return d;
  }

  public static String FormatDouble(double d, int length)
  {
    //System.out.println("FormatDouble("+d+", "+length+")");
    String str = Double.toString(d);
    //System.out.println("FormatDouble str = "+str);
    if(str.length() < length)
      {
	return str;
      }
    int eindex = str.indexOf('E');
    String exponent = "";
    //System.out.println("FormatDouble eindex = "+eindex);
    if(eindex > 0)
      {
	exponent = str.substring(eindex);
	str = str.substring(0,eindex);
      }
    else
      {
	int pindex = str.indexOf('.');
	//System.out.println("FormatDouble pindex = "+pindex);
	if(pindex > 2)
	  {
	    if(pindex > length -1)
	      {
		exponent = "E" + (pindex-1);
		str = str.charAt(0)+"."+str.substring(1,pindex) + str.substring(pindex+1);
	      }
	  }
	else
	  {
	    int exponent_int =0;
	    int i = 0;
	    for( i = 0; i < str.length(); i++)
	      {
		if(str.charAt(i) != '0' && 
		   str.charAt(i) != '.')
		  {
		    break;
		  }
		if(i > pindex)
		  {
		    exponent_int--;	
		  }
	      }
	    //System.out.println("FormatDouble exponent_int = "+exponent_int);
	    if(exponent_int < -3)
	      {
		exponent = "E"+exponent_int;
		//System.out.println("FormatDouble i = "+i);
		//System.out.println("FormatDouble str.charAt(i) = "+str.charAt(i));
		//System.out.println("FormatDouble str.substring(i+1) = "+str.substring(i+1));
		//System.out.println(	str.charAt(i)+'.'+str.substring(i+1));
		str = str.charAt(i)+"."+str.substring(i+1);
	      }
	  }
      }
    //System.out.println("FormatDouble str = "+str);
    //System.out.println("FormatDouble exponent = "+exponent);
    str = str.substring(0,(length - exponent.length()))+exponent;
    while(true)
      {
	char last_char = str.charAt(str.length() -1);
	int pindex = str.indexOf('.');
	if(last_char != ' ' && last_char != '.' &&
	   (last_char != '0' || pindex == -1))
	  {
	    break;
	  }
	str = str.substring(0, str.length()-1);
      }
    return str;
  }
	
  boolean font_set = false;
  int lineheight = 100;

  String XString = "";
  String YString = "";
  String ZString = "";

  public void UpdateStrings()
  {
    if(unit_type == INCH_UNITS)
      {
	XString = "X:"+FormatDouble(x*MILLIMETERS_TO_INCHES,9)+" in.";
	YString = "Y:"+FormatDouble(y*MILLIMETERS_TO_INCHES,9)+" in.";
	ZString = "Z:"+FormatDouble(z*MILLIMETERS_TO_INCHES,9)+" in.";
      }
    else
      {
	XString = "X:"+FormatDouble(x,9)+" mm.";
	YString = "Y:"+FormatDouble(y,9)+" mm.";
	ZString = "Z:"+FormatDouble(z,9)+" mm.";
      }
  }

  //--------------------------------------------------------------------------
  public void paint(Graphics g)
  {
    try
      {
	if(null == g)
	  {
	    System.out.println("PositionDisplayPanel.paint(): g = null\n");
	    return;
	  }
	g.setColor(Color.yellow);
	if(null == d)
	  {
	    System.out.println("PositionDisplayPanel.paint(): d = null\n");
	    return;
	  }
	g.drawString(XString, 50,lineheight);
	g.drawString(YString, 50,lineheight*2);
	g.drawString(ZString, 50,lineheight*3);
		
      }
    catch(Exception e)
      {
	e.printStackTrace();
      }
  }


}

