@echo off
REM Batch script to run EMC on Windows
REM
REM Written by Alex Joni (GPL)
REM 

REM Make sure you have tcl, and tk installed and defined here
set TCL_LIBRARY=c:\Program Files\tcl\lib\tcl8.2
set TK_LIBRARY=c:\Program Files\tcl\lib\tk8.2

REM Same goes for wish (it is used for the popimage, if you don't have one uncomment the
REM popimage line)
set TK_BIN="c:\Program Files\tk\win\Release\wish82.exe"

REM popimage
for /F %%I IN ('plat\win32msc\bin\Release\inivar.exe -ini sim.ini -var INTRO_GRAPHIC -sec DISPLAY') DO %TK_BIN% tcl\popimage.tcl %%I

rem
rem Checking for inpout32.dll
rem If it doesn't exist it will be copied

if exist %WINDIR%\SYSTEM32\inpout32.dll goto EXISTS
copy plat\win32msc\bin\utils\inpout32.dll %WINDIR%\SYSTEM32\

:EXISTS

rem ------
rem Motion
rem ------
for /F %%I IN ('plat\win32msc\bin\Release\inivar.exe -ini sim.ini -var EMCMOT -sec EMCMOT') DO start plat\win32msc\bin\Release\%%I -ini sim.ini

pause

rem ------
rem I/O
rem ------
start plat\win32msc\bin\Release\mmio.exe -ini sim.ini

pause

rem ------
rem Task
rem ------
start plat\win32msc\bin\Release\mmtask.exe -ini sim.ini

pause

rem ------
rem emcsrv
rem ------
rem 
rem If one is enabled in the EMCSERVER of the sim.ini file, it will be run
rem Modify the sim.nml file accordingly
rem ------
for /F %%I IN ('plat\win32msc\bin\Release\inivar.exe -ini sim.ini -var EMCSERVER -sec EMCSERVER') DO start plat\win32msc\bin\Release\%%I -ini sim.ini

rem ------
rem GUI
rem ------
for /F %%I IN ('plat\win32msc\bin\Release\inivar.exe -ini sim.ini -var DISPLAY -sec DISPLAY') DO call %%I

rem ------
rem Uncomment the next line for the Java GUI
rem ------
rem
rem java -cp plat\java\lib\emc.jar emc.gui.NCapplet RunLocal=true InitFile=sim.ini ToolTable=sim.tbl NMLfile=sim.nml
