#!/bin/sh
# the next line restarts using emcsh \
exec plat/nonrealtime/bin/emcsh "$0" "$@"

# Dummy routine to test the mouse interface
#
# First, we need to initalise the mouse.
# Valid ports are /dev/psaux /dev/ttyS0 and /dev/ttyS1
set mouse "/dev/ttyS1"
exec gpm -m $mouse
# Assumes standard two button mouse - Untested with
# three button and scroll mice.

# Don't use "gpm -k" to kill gpm within xwindows - It
#  destroys the normal mouse operation and you'll have
#  to restart xwindows to regain the mouse.

set y 0
while {$y == 0} {

set x [emc_pendant $mouse]

# Print out the pendant data
# Left Button, Right Button, Signed X move, Signed Y move, Mouse Flags

puts -nonewline [lindex $x 0]
# 1 or 0 depending on Left button status
puts -nonewline " "
puts -nonewline [lindex $x 1]
# 1 or 0 depending on Right button status
puts -nonewline " "
puts -nonewline [lindex $x 2]
# X move in the range of -127 to +127 for PS/2 mice
# and -31 to +31 for standard serial mice using the
# Microsoft protocols (with a little bit of work on
# the C routine, this can be extended)
puts -nonewline " "
puts -nonewline [lindex $x 3]
# Y move - See above note for range.
puts -nonewline " "
puts [lindex $x 4]
# Mouse Flags are just here to verify correct mouse operation.
}
